'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _raw_countries_icons = require('./raw_countries_icons');

var _raw_countries_icons2 = _interopRequireDefault(_raw_countries_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * CountryIcon component.
 */
var CountryIcon = function CountryIcon(props) {
  var code = props.code,
      other = _objectWithoutProperties(props, ['code']);

  var icon = _raw_countries_icons2.default[code];

  if (!icon) {
    return null;
  }

  return React.createElement('svg', _extends({}, other, {
    xmlns: 'http://www.w3.org/2000/svg',
    viewBox: icon[0]
    // eslint-disable-next-line react/no-danger
    , dangerouslySetInnerHTML: { __html: icon[1] }
  }));
};

CountryIcon.propTypes = {
  code: _propTypes2.default.string.isRequired
};

exports.default = CountryIcon;
//# sourceMappingURL=country_icon.js.map