'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var formatNumber = exports.formatNumber = function formatNumber(text, country) {
  if (!country) {
    return text;
  }

  text = text.replace(/\D/g, '');

  var format = country.format;

  var pattern = format;

  if (!text || text.length === 0) {
    return '+';
  }

  // for all strings with length less than 3, just return it (1, 2 etc.)
  // also return the same text if the selected country has no fixed format
  if (text && text.length < 2 || !pattern) {
    return '+' + text;
  }

  var formattedObject = pattern.split('').reduce(function (acc, character) {
    if (acc.remainingText.length === 0) {
      return acc;
    }

    if (character !== '.') {
      return {
        formattedText: acc.formattedText + character,
        remainingText: acc.remainingText
      };
    }

    var _acc$remainingText = _toArray(acc.remainingText),
        head = _acc$remainingText[0],
        tail = _acc$remainingText.slice(1);

    return {
      formattedText: acc.formattedText + head,
      remainingText: tail
    };
  }, {
    formattedText: '',
    remainingText: text.split('')
  });

  return formattedObject.formattedText;
};

exports.default = formatNumber;
//# sourceMappingURL=format_number.js.map