'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PhoneField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactPopper = require('react-popper');

var _analytics_hoc = require('../../containers/analytics_hoc');

var _analytics_hoc2 = _interopRequireDefault(_analytics_hoc);

var _select_dropdown = require('../select/select_dropdown');

var _select_dropdown2 = _interopRequireDefault(_select_dropdown);

var _select_item = require('../select/select_item');

var _select_item2 = _interopRequireDefault(_select_item);

var _text_field = require('../text_field');

var _text_field2 = _interopRequireDefault(_text_field);

var _select_arrow = require('../icons/select_arrow');

var _select_arrow2 = _interopRequireDefault(_select_arrow);

var _format_number = require('./format_number');

var _countries = require('./countries');

var _country_icon = require('./country_icon');

var _country_icon2 = _interopRequireDefault(_country_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/forbid-prop-types */
/* eslint-disable react/require-default-props */


/**
 * PhoneField component.
 */
var PhoneField = exports.PhoneField = function (_React$Component) {
  _inherits(PhoneField, _React$Component);

  function PhoneField(props) {
    _classCallCheck(this, PhoneField);

    var _this = _possibleConstructorReturn(this, (PhoneField.__proto__ || Object.getPrototypeOf(PhoneField)).call(this, props));

    _initialiseProps.call(_this);

    var country = _countries.countries[props.defaultCountry] || _countries.countries.US;
    var value = '';

    if (props.defaultValue) {
      if (props.defaultValue.startsWith(country.dialCode)) {
        value = (0, _format_number.formatNumber)(props.defaultValue, country);
      } else {
        console.warn('Warning:', 'PhoneField component `defaultValue` prop doesn\'t match country dial code. Please change `defaultCountry` or `defaultValue` prop.');
      }
    }

    _this.state = {
      showOptions: false,
      activeOption: country,
      inputValue: value
    };
    return _this;
  }

  _createClass(PhoneField, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('click', this.handleClickOutside);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('click', this.handleClickOutside);
    }
  }, {
    key: 'focus',


    /**
     * Focus input element.
     */
    value: function focus() {
      this.refTextField.current.focus();
    }
  }, {
    key: 'focusPrevOptionInDropdown',
    value: function focusPrevOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption('prev');
      }
    }
  }, {
    key: 'focusNextOptionInDropdown',
    value: function focusNextOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption();
      }
    }
  }, {
    key: 'focusValueMatchedOptionInDropdown',
    value: function focusValueMatchedOptionInDropdown(value) {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOptionByValue(value);
      }
    }
  }, {
    key: 'clickOnFocusedOptionInDropdown',
    value: function clickOnFocusedOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.clickToFocusedElement();
      }
    }
  }, {
    key: 'handleOnChangeCallback',
    value: function handleOnChangeCallback(event, newValue, reason) {
      var _props = this.props,
          name = _props.name,
          required = _props.required,
          onChange = _props.onChange;
      var _state = this.state,
          inputValue = _state.inputValue,
          activeOption = _state.activeOption;

      // Prevent create event if prop `onChange` is empty.

      if (typeof onChange !== 'function') {
        return;
      }

      // Prevent choose the same value.
      if (newValue === inputValue) {
        return;
      }

      // Simulate empty value if value is equal `dialCode`.
      if (newValue === activeOption.dialCode) {
        newValue = '';
      }

      event.persist();

      Object.defineProperty(event, 'target', {
        writable: true,
        value: {
          name: name,
          value: newValue.replace(/\s/g, ''),
          required: required,
          country: {
            name: activeOption.name,
            code: activeOption.code,
            dialCode: activeOption.dialCode
          }
        }
      });

      onChange(event, reason);
    }
  }, {
    key: 'renderOpenButton',
    value: function renderOpenButton() {
      var disabled = this.props.disabled;
      var _state2 = this.state,
          activeOption = _state2.activeOption,
          showOptions = _state2.showOptions;


      return React.createElement(
        'button',
        {
          onClick: this.handleClickSelectButton,
          onKeyDown: this.handleKeyDownSelectButton,
          type: 'button',
          className: (0, _classnames2.default)('phone_field_button_country', {
            phone_field_button_country_open: showOptions
          }),
          disabled: disabled,
          'aria-label': showOptions ? 'Close' : 'Open',
          title: showOptions ? 'Close' : 'Open'
        },
        React.createElement(_country_icon2.default, {
          code: activeOption.code,
          className: 'phone_field_icon_country'
        }),
        React.createElement(_select_arrow2.default, {
          className: 'phone_field_icon_arrow'
        })
      );
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions() {
      var _this2 = this;

      var size = this.props.size;
      var activeOption = this.state.activeOption;


      return Object.keys(_countries.countries).map(function (code, index) {
        var option = _countries.countries[code];

        return React.createElement(
          _select_item2.default,
          {
            key: option.code,
            value: option.code,
            'data-option-index': index,
            onClick: _this2.handleClickOption(option),
            selected: activeOption.code === option.code,
            size: size
          },
          React.createElement(_country_icon2.default, {
            code: code,
            className: 'phone_field_icon_country'
          }),
          option.name,
          ' ',
          React.createElement(
            'span',
            { className: 'phone_field_text_dial_code' },
            option.dialCode
          )
        );
      });
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup() {
      var _props2 = this.props,
          placement = _props2.placement,
          flip = _props2.flip;


      return React.createElement(
        _reactPopper.Popper,
        {
          modifiers: {
            computeStyle: {
              gpuAcceleration: false
            },
            preventOverflow: {
              enabled: false
            },
            hide: {
              enabled: false
            },
            flip: {
              enabled: flip
            }
          },
          positionFixed: false,
          referenceElement: this._refRootElement ? this._refRootElement.current : null,
          placement: placement
        },
        this.renderDropDown()
      );
    }
  }, {
    key: 'renderField',
    value: function renderField() {
      var _props3 = this.props,
          disabled = _props3.disabled,
          placeholder = _props3.placeholder,
          required = _props3.required,
          bgType = _props3.bgType,
          color = _props3.color,
          textColor = _props3.textColor,
          colorFocus = _props3.colorFocus,
          colorError = _props3.colorError,
          size = _props3.size,
          valid = _props3.valid,
          placeholderColor = _props3.placeholderColor,
          name = _props3.name,
          mobileSize = _props3.mobileSize,
          inputProps = _props3.inputProps,
          tabIndex = _props3.tabIndex,
          autoFocus = _props3.autoFocus,
          onKeyDown = _props3.onKeyDown,
          children = _props3.children;
      var inputValue = this.state.inputValue;


      return React.createElement(
        _text_field2.default,
        {
          type: 'tel',
          value: inputValue,
          onChange: this.handleChangeField,
          onBlur: this.handleBlurField,
          onFocus: this.handleFocusField,
          onClick: this.handleClickField,
          onKeyDown: onKeyDown,
          disabled: disabled,
          placeholder: placeholder,
          required: required,
          bgType: bgType,
          color: color,
          textColor: textColor,
          colorFocus: colorFocus,
          colorError: colorError,
          size: size,
          valid: valid,
          placeholderColor: placeholderColor,
          name: name,
          mobileSize: mobileSize,
          inputProps: _extends({}, inputProps, {
            className: 'phone_field_input'
          }),
          tabIndex: tabIndex,
          autoFocus: autoFocus,
          ref: this.refTextField
        },
        children
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          autoFocus = _props4.autoFocus,
          bgType = _props4.bgType,
          className = _props4.className,
          color = _props4.color,
          colorFocus = _props4.colorFocus,
          colorError = _props4.colorError,
          disabled = _props4.disabled,
          flip = _props4.flip,
          inputProps = _props4.inputProps,
          mobileSize = _props4.mobileSize,
          name = _props4.name,
          onBlur = _props4.onBlur,
          onFocus = _props4.onFocus,
          onChange = _props4.onChange,
          onKeyDown = _props4.onKeyDown,
          placeholder = _props4.placeholder,
          placeholderColor = _props4.placeholderColor,
          placement = _props4.placement,
          required = _props4.required,
          size = _props4.size,
          tabIndex = _props4.tabIndex,
          textColor = _props4.textColor,
          valid = _props4.valid,
          defaultCountry = _props4.defaultCountry,
          children = _props4.children,
          other = _objectWithoutProperties(_props4, ['autoFocus', 'bgType', 'className', 'color', 'colorFocus', 'colorError', 'disabled', 'flip', 'inputProps', 'mobileSize', 'name', 'onBlur', 'onFocus', 'onChange', 'onKeyDown', 'placeholder', 'placeholderColor', 'placement', 'required', 'size', 'tabIndex', 'textColor', 'valid', 'defaultCountry', 'children']);

      var showOptions = this.state.showOptions;


      return React.createElement(
        'div',
        _extends({}, other, {
          'data-component': 'phone_field',
          className: (0, _classnames2.default)('phone_field', className),
          ref: this._refRootElement
        }),
        this.renderOpenButton(),
        this.renderField(),
        showOptions && this.renderPopup()
      );
    }
  }]);

  return PhoneField;
}(React.Component);

PhoneField.propTypes = {
  /**
   * The default selected country.
   */
  defaultCountry: _propTypes2.default.string,
  /**
   * The default input value, useful when not controlling the component.
   */
  defaultValue: _propTypes2.default.string,
  /**
   * If true, the input will be disabled.
   */
  disabled: _propTypes2.default.bool,
  /**
   * The short hint displayed in the input before the user enters a value.
   */
  placeholder: _propTypes2.default.string,
  /**
   * The CSS class name of the wrapper element.
   */
  className: _propTypes2.default.string,
  /**
   * If true, the input will be required.
   */
  required: _propTypes2.default.bool,
  /**
   * If false, the input will be unvalid styles.
   */
  valid: _propTypes2.default.bool,
  /**
   * Component type one of `fill` or `stroke`.
   * If `fill` - component will be have background-color from `color` props.
   * If `stroke` - component will be have border-color from `color` props.
   */
  bgType: _propTypes2.default.oneOf(['fill', 'stroke']),
  /**
   * Component color from theme.
   */
  color: _propTypes2.default.string,
  /**
   * Component text color from theme.
   */
  textColor: _propTypes2.default.string,
  /**
   * Color for the placeholder.
   */
  placeholderColor: _propTypes2.default.string,
  /**
   * Component focus color from theme.
   */
  colorFocus: _propTypes2.default.string,
  /**
   * Component error color from the theme.
   */
  colorError: _propTypes2.default.string,
  /**
   * Component size.
   */
  size: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Component size for mobile.
   */
  mobileSize: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Name attribute of the input element.
   */
  name: _propTypes2.default.string,
  /**
   * Input tabIndex.
   */
  tabIndex: _propTypes2.default.number,
  /**
   * If true, the input will be focused during the first mount.
   */
  autoFocus: _propTypes2.default.bool,
  /**
   * Properties applied to the input element.
   */
  inputProps: _propTypes2.default.object,
  /**
   * Component dropdown start opened direction.
   */
  placement: _propTypes2.default.oneOf(['top', 'bottom']),
  /**
   * If `true`, component will automatically calc possible dropdown opened direction.
   */
  flip: _propTypes2.default.bool,
  /**
   * Callback fired when the value is changed.
   */
  onChange: _propTypes2.default.func,
  /**
   * Callback fired when the input left focus.
   */
  onBlur: _propTypes2.default.func,
  /**
   * Callback fired when the input receives focus.
   */
  onFocus: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  /**
   * This is what will be displayed in wrapper component.
   */
  children: _propTypes2.default.node
};
PhoneField.defaultProps = {
  defaultCountry: 'US',
  defaultValue: '',
  disabled: false,
  required: false,
  bgType: 'stroke',
  color: 'light_grey',
  textColor: 'black',
  placeholderColor: 'grey_4',
  colorFocus: 'primary',
  colorError: 'wrong',
  size: 'medium',
  tabIndex: 0,
  autoFocus: false,
  inputProps: {},
  placement: 'bottom',
  flip: true
};

var _initialiseProps = function _initialiseProps() {
  var _this3 = this;

  this._refRootElement = React.createRef();
  this._refSelectDropdown = React.createRef();
  this.refTextField = React.createRef();

  this.handleChangeField = function (event) {
    var _state3 = _this3.state,
        activeOption = _state3.activeOption,
        inputValue = _state3.inputValue;
    var value = event.target.value;

    /**
     * If value is empty, show country dial code.
     */

    if (!value.length) {
      _this3.setState({
        inputValue: activeOption.dialCode
      });

      _this3.handleOnChangeCallback(event, activeOption.dialCode);

      return;
    }

    /**
     * Safari paste phone number without country code.
     */
    if (value[0] !== '+') {
      value = '' + activeOption.dialCode + value;
    }

    if (value.slice(0, activeOption.dialCode.length) !== activeOption.dialCode) {
      return;
    }

    var formattedNumber = (0, _format_number.formatNumber)(value, activeOption);
    var diff = formattedNumber.length - inputValue.length;
    var caretPosition = event.target.selectionStart;

    _this3.setState({
      inputValue: formattedNumber
    }, function () {
      if (diff > 0) {
        caretPosition -= diff;
      }

      var numberInputRef = _this3.refTextField.current.inputNode.inputNode;

      if (caretPosition > 0 && inputValue.length >= formattedNumber.length) {
        numberInputRef.setSelectionRange(caretPosition, caretPosition);
      }
    });

    _this3.handleOnChangeCallback(event, formattedNumber);
  };

  this.handleBlurField = function (event) {
    var onBlur = _this3.props.onBlur;
    var _state4 = _this3.state,
        inputValue = _state4.inputValue,
        activeOption = _state4.activeOption;

    var isInputValueTheSameAsCountryDialCode = inputValue === activeOption.dialCode;

    _this3.setState({
      showOptions: false,
      // Clear the field value if value is equal to `dialCode`.
      inputValue: isInputValueTheSameAsCountryDialCode ? '' : inputValue
    });

    if (typeof onBlur === 'function') {
      onBlur(event);
    }
  };

  this.handleFocusField = function (event) {
    var onFocus = _this3.props.onFocus;


    _this3.setState(function (prevState) {
      return {
        showOptions: false,
        // Show `dialCode` when the field is empty.
        inputValue: prevState.inputValue || prevState.activeOption.dialCode
      };
    });

    if (typeof onFocus === 'function') {
      onFocus(event);
    }
  };

  this.handleClickOption = function (option) {
    return function (event) {
      var _state5 = _this3.state,
          activeOption = _state5.activeOption,
          inputValue = _state5.inputValue;

      var isNextOptionTheSame = activeOption.code === option.code;

      _this3.setState({
        showOptions: false,
        activeOption: option,
        inputValue: isNextOptionTheSame ? inputValue : option.dialCode
      }, function () {
        // Prevent call change event for the same option.
        if (!isNextOptionTheSame) {
          _this3.handleOnChangeCallback(event, '', 'select-option');
        }
      });

      _this3.refTextField.current.focus();
    };
  };

  this.handleClickSelectButton = function () {
    var showOptions = _this3.state.showOptions;


    _this3.setState({
      showOptions: !showOptions
    });
  };

  this.handleMouseDownForPreventBlur = function (event) {
    // Prevent blur
    event.preventDefault();
  };

  this.handleClickOutside = function (event) {
    var showOptions = _this3.state.showOptions;


    if (showOptions && !_this3._refRootElement.current.contains(event.target)) {
      _this3.setState({
        showOptions: false
      });
    }
  };

  this.handleKeyDownSelectButton = function (event) {
    var showOptions = _this3.state.showOptions;

    // Wait until IME is settled.

    if (event.which !== 229) {
      switch (event.key) {
        case 'ArrowUp':
          {
            // Prevent scroll of the page
            event.preventDefault();

            if (!showOptions) {
              _this3.setState({
                showOptions: true
              });
            }

            _this3.focusPrevOptionInDropdown();

            break;
          }

        case 'ArrowDown':
          {
            // Prevent scroll of the page
            event.preventDefault();

            if (!showOptions) {
              _this3.setState({
                showOptions: true
              });
            }

            _this3.focusNextOptionInDropdown();

            break;
          }

        case ' ':
          {
            event.preventDefault();

            if (!showOptions) {
              _this3.setState({
                showOptions: true
              });
            }

            break;
          }

        case 'Enter':
          {
            if (showOptions) {
              event.preventDefault();

              _this3.clickOnFocusedOptionInDropdown();
            }

            break;
          }

        case 'Escape':
          {
            // Avoid Opera to exit fullscreen mode.
            event.preventDefault();
            // Avoid the Modal to handle the event.
            event.stopPropagation();

            _this3.setState({
              showOptions: false
            });

            break;
          }

        default:
          if (showOptions) {
            _this3.focusValueMatchedOptionInDropdown(event.key);
          }
      }
    }
  };

  this.renderDropDown = function () {
    return function (props) {
      return React.createElement(
        'div',
        {
          ref: props.ref,
          style: {
            top: 0,
            left: 0,
            position: props.style.position,
            transform: 'translate3d(0px, ' + props.style.top + 'px, 0px)',
            transformOrigin: 'top center'
          },
          className: 'select_dropdown_container'
        },
        React.createElement(
          _select_dropdown2.default,
          {
            ref: _this3._refSelectDropdown,
            onMouseDown: _this3.handleMouseDownForPreventBlur
          },
          _this3.renderOptions()
        )
      );
    };
  };
};

exports.default = (0, _analytics_hoc2.default)(PhoneField, 'onChange');
//# sourceMappingURL=index.js.map