'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactPopper = require('react-popper');

var _select_dropdown = require('./select_dropdown');

var _select_dropdown2 = _interopRequireDefault(_select_dropdown);

var _select_item = require('./select_item');

var _select_item2 = _interopRequireDefault(_select_item);

var _text_field = require('../text_field');

var _text_field2 = _interopRequireDefault(_text_field);

var _select_arrow = require('../icons/select_arrow');

var _select_arrow2 = _interopRequireDefault(_select_arrow);

var _analytics_hoc = require('../../containers/analytics_hoc');

var _analytics_hoc2 = _interopRequireDefault(_analytics_hoc);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable react/require-default-props */


/**
 * Select component
 */
var Select = function (_React$Component) {
  _inherits(Select, _React$Component);

  function Select() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Select);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showOptions: false,
      activeOption: _this.props.value || _this.props.defaultValue
    }, _this.setValue = function (value) {
      return _this.setState({
        activeOption: value
      });
    }, _this._refRootElement = React.createRef(), _this._refSelectDropdown = React.createRef(), _this.refTextField = React.createRef(), _this.handleBlurField = function (event) {
      var onBlur = _this.props.onBlur;


      _this.setState({
        showOptions: false
      });

      if (typeof onBlur === 'function') {
        onBlur(event);
      }
    }, _this.handleKeyDownField = function (event) {
      var _this$props = _this.props,
          disabled = _this$props.disabled,
          onKeyDown = _this$props.onKeyDown;
      var showOptions = _this.state.showOptions;


      if (disabled) {
        return;
      }

      if (typeof onKeyDown === 'function') {
        onKeyDown(event);
      }

      // Wait until IME is settled.
      if (event.which !== 229) {
        switch (event.key) {
          case 'ArrowUp':
            {
              // Prevent scroll of the page
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              _this.focusPrevOptionInDropdown();

              break;
            }

          case 'ArrowDown':
            {
              // Prevent scroll of the page
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              _this.focusNextOptionInDropdown();

              break;
            }

          case ' ':
            {
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              break;
            }

          case 'Enter':
            {
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              _this.clickOnFocusedOptionInDropdown();

              break;
            }

          case 'Escape':
            {
              // Avoid Opera to exit fullscreen mode.
              event.preventDefault();
              // Avoid the Modal to handle the event.
              event.stopPropagation();

              _this.setState({
                showOptions: false
              });

              break;
            }

          default:
            if (showOptions) {
              _this.focusValueMatchedOptionInDropdown(event.key);
            }
        }
      }
    }, _this.handleBlurField = function (event) {
      var onBlur = _this.props.onBlur;


      _this.setState({
        showOptions: false
      });

      if (typeof onBlur === 'function') {
        onBlur(event);
      }
    }, _this.handleClickField = function () {
      var disabled = _this.props.disabled;
      var showOptions = _this.state.showOptions;


      if (disabled) {
        return;
      }

      _this.setState({
        showOptions: !showOptions
      });
    }, _this.handleClickOption = function (option) {
      return function (event) {
        var _this$props2 = _this.props,
            onChange = _this$props2.onChange,
            name = _this$props2.name,
            required = _this$props2.required;
        var activeOption = _this.state.activeOption;

        // Prevent choose the same value.

        if (activeOption === option.value) {
          _this.setState({
            showOptions: false
          });

          return;
        }

        if ('value' in _this.props) {
          _this.setState({
            showOptions: false
          });
        } else {
          _this.setState({
            showOptions: false,
            activeOption: option.value
          });
        }

        if (typeof onChange === 'function') {
          event.persist();

          Object.defineProperty(event, 'target', {
            writable: true,
            value: {
              name: name,
              value: option.value,
              required: required
            }
          });

          onChange(event);
        }
      };
    }, _this.handleMouseDownForPreventBlur = function (event) {
      // Prevent blur
      event.preventDefault();
    }, _this.renderDropDown = function (options) {
      return function (props) {
        return React.createElement(
          'div',
          {
            ref: props.ref,
            style: {
              top: 0,
              left: 0,
              position: props.style.position,
              transform: 'translate3d(0px, ' + props.style.top + 'px, 0px)',
              transformOrigin: 'top center'
            },
            className: 'select_dropdown_container'
          },
          React.createElement(
            _select_dropdown2.default,
            {
              ref: _this._refSelectDropdown,
              onMouseDown: _this.handleMouseDownForPreventBlur
            },
            _this.renderOptions(options)
          )
        );
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Select, [{
    key: 'getValue',


    /**
     * Get components value.
     * @return {string|number}
     */
    value: function getValue() {
      return this.state.activeOption;
    }

    /**
     * Set select value
     * @param {string|number} value
     */

  }, {
    key: 'focus',


    /**
     * Focus input element.
     */
    value: function focus() {
      this.refTextField.current.focus();
    }
  }, {
    key: 'focusPrevOptionInDropdown',
    value: function focusPrevOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption('prev');
      }
    }
  }, {
    key: 'focusNextOptionInDropdown',
    value: function focusNextOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption();
      }
    }
  }, {
    key: 'focusValueMatchedOptionInDropdown',
    value: function focusValueMatchedOptionInDropdown(value) {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOptionByValue(value);
      }
    }
  }, {
    key: 'clickOnFocusedOptionInDropdown',
    value: function clickOnFocusedOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.clickToFocusedElement();
      }
    }
  }, {
    key: 'renderOpenButton',
    value: function renderOpenButton() {
      var iconComponent = this.props.iconComponent;
      var showOptions = this.state.showOptions;


      return React.createElement(
        'div',
        {
          className: (0, _classnames2.default)('select_button', {
            select_button_open: showOptions
          })
          // eslint-disable-next-line react/no-unknown-property
          , focusable: 'false',
          'aria-hidden': true
        },
        iconComponent || React.createElement(_select_arrow2.default, { className: 'select_arrow_icon' })
      );
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions(options) {
      var _this2 = this;

      var _props = this.props,
          size = _props.size,
          renderOption = _props.renderOption,
          getOptionDisabled = _props.getOptionDisabled;
      var activeOption = this.state.activeOption;


      return options.map(function (option, index) {
        return React.createElement(
          _select_item2.default,
          {
            key: option.value,
            value: option.value,
            'data-option-index': index,
            selected: activeOption === option.value,
            size: size,
            onClick: _this2.handleClickOption(option),
            disabled: typeof getOptionDisabled === 'function' ? getOptionDisabled(option) : false
          },
          typeof renderOption === 'function' ? renderOption(option) : option.label
        );
      });
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup(options) {
      var _props2 = this.props,
          placement = _props2.placement,
          flip = _props2.flip;


      return React.createElement(
        _reactPopper.Popper,
        {
          modifiers: {
            computeStyle: {
              gpuAcceleration: false
            },
            preventOverflow: {
              enabled: false
            },
            hide: {
              enabled: false
            },
            flip: {
              enabled: flip
            }
          },
          positionFixed: false,
          referenceElement: this._refRootElement ? this._refRootElement.current : null,
          placement: placement
        },
        this.renderDropDown(options)
      );
    }
  }, {
    key: 'renderField',
    value: function renderField() {
      var _props3 = this.props,
          disabled = _props3.disabled,
          placeholder = _props3.placeholder,
          required = _props3.required,
          bgType = _props3.bgType,
          color = _props3.color,
          textColor = _props3.textColor,
          colorFocus = _props3.colorFocus,
          size = _props3.size,
          placeholderColor = _props3.placeholderColor,
          name = _props3.name,
          mobileSize = _props3.mobileSize,
          inputProps = _props3.inputProps,
          options = _props3.options,
          tabIndex = _props3.tabIndex,
          autoFocus = _props3.autoFocus,
          onFocus = _props3.onFocus;
      var activeOption = this.state.activeOption;

      var option = options.find(function (opt) {
        return opt.value === activeOption;
      });

      return React.createElement(
        _text_field2.default,
        {
          autoComplete: 'off',
          className: 'select_field',
          onBlur: this.handleBlurField,
          onFocus: onFocus,
          onClick: this.handleClickField,
          onKeyDown: this.handleKeyDownField,
          value: option ? option.label : '',
          disabled: disabled,
          placeholder: placeholder,
          required: required,
          bgType: bgType,
          color: color,
          textColor: textColor,
          colorFocus: colorFocus,
          size: size,
          placeholderColor: placeholderColor,
          name: name,
          mobileSize: mobileSize,
          inputProps: _extends({}, inputProps, {
            readOnly: true,
            className: 'select_input'
          }),
          tabIndex: tabIndex,
          autoFocus: autoFocus,
          ref: this.refTextField
        },
        this.renderOpenButton()
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props4 = this.props,
          autoFocus = _props4.autoFocus,
          bgType = _props4.bgType,
          className = _props4.className,
          color = _props4.color,
          colorFocus = _props4.colorFocus,
          defaultValue = _props4.defaultValue,
          disabled = _props4.disabled,
          flip = _props4.flip,
          iconComponent = _props4.iconComponent,
          inputProps = _props4.inputProps,
          mobileSize = _props4.mobileSize,
          name = _props4.name,
          onBlur = _props4.onBlur,
          onFocus = _props4.onFocus,
          onChange = _props4.onChange,
          onKeyDown = _props4.onKeyDown,
          options = _props4.options,
          placeholder = _props4.placeholder,
          placeholderColor = _props4.placeholderColor,
          placement = _props4.placement,
          renderOption = _props4.renderOption,
          getOptionDisabled = _props4.getOptionDisabled,
          required = _props4.required,
          size = _props4.size,
          tabIndex = _props4.tabIndex,
          textColor = _props4.textColor,
          value = _props4.value,
          other = _objectWithoutProperties(_props4, ['autoFocus', 'bgType', 'className', 'color', 'colorFocus', 'defaultValue', 'disabled', 'flip', 'iconComponent', 'inputProps', 'mobileSize', 'name', 'onBlur', 'onFocus', 'onChange', 'onKeyDown', 'options', 'placeholder', 'placeholderColor', 'placement', 'renderOption', 'getOptionDisabled', 'required', 'size', 'tabIndex', 'textColor', 'value']);

      var showOptions = this.state.showOptions;


      return React.createElement(
        'div',
        _extends({}, other, {
          'data-component': 'select',
          className: (0, _classnames2.default)('select', className),
          ref: this._refRootElement
        }),
        this.renderField(),
        showOptions && this.renderPopup(options)
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      if ('value' in props && props.value !== state.activeOption) {
        return {
          activeOption: props.value
        };
      }

      return null;
    }
  }]);

  return Select;
}(React.Component);

Select.propTypes = {
  /**
   * The default input value, useful when not controlling the component.
   */
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * The input value.
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * Array of options.
   */
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
  })).isRequired,
  /**
   * Render the option.
   */
  renderOption: _propTypes2.default.func,
  /**
   * Used to determine the disabled state for a given option.
   */
  getOptionDisabled: _propTypes2.default.func,
  /**
   * If true, the input will be disabled.
   */
  disabled: _propTypes2.default.bool,
  /**
   * The short hint displayed in the input before the user enters a value.
   */
  placeholder: _propTypes2.default.string,
  /**
   * The CSS class name of the wrapper element.
   */
  className: _propTypes2.default.string,
  /**
   * If true, the input will be required.
   */
  required: _propTypes2.default.bool,
  /**
   * Component type one of `fill` or `stroke`.
   * If `fill` - component will be have background-color from `color` props.
   * If `stroke` - component will be have border-color from `color` props.
   */
  bgType: _propTypes2.default.oneOf(['fill', 'stroke']),
  /**
   * Component color from theme.
   */
  color: _propTypes2.default.string,
  /**
   * Component text color from theme.
   */
  textColor: _propTypes2.default.string,
  /**
   * Color for the placeholder.
   */
  placeholderColor: _propTypes2.default.string,
  /**
   * Component focus color from theme.
   */
  colorFocus: _propTypes2.default.string,
  /**
   * Component size.
   */
  size: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Component size for mobile.
   */
  mobileSize: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Name attribute of the input element.
   */
  name: _propTypes2.default.string,
  /**
   * Element tabIndex.
   */
  tabIndex: _propTypes2.default.number,
  /**
   * If true, the input will be focused during the first mount.
   */
  autoFocus: _propTypes2.default.bool,
  /**
   * Properties applied to the input element.
   */
  inputProps: _propTypes2.default.oneOfType([_propTypes2.default.object]),
  /**
   * Component dropdown start opened direction.
   */
  placement: _propTypes2.default.oneOf(['top', 'bottom']),
  /**
   * If `true`, component will automatically calc possible dropdown opened direction.
   */
  flip: _propTypes2.default.bool,
  /**
   * Callback fired when the value is changed.
   */
  onChange: _propTypes2.default.func,
  /**
   * Callback fired when the input left focus.
   */
  onBlur: _propTypes2.default.func,
  /**
   * Callback fired when the input receives focus.
   */
  onFocus: _propTypes2.default.func,
  onKeyDown: _propTypes2.default.func,
  /**
   * The icon that displays the arrow.
   */
  iconComponent: _propTypes2.default.node
};
Select.defaultProps = {
  defaultValue: '',
  disabled: false,
  required: false,
  bgType: 'stroke',
  color: 'light_grey',
  textColor: 'black',
  placeholderColor: 'grey_4',
  colorFocus: 'primary',
  size: 'medium',
  tabIndex: 0,
  autoFocus: false,
  inputProps: {},
  placement: 'bottom',
  flip: true
};
exports.default = (0, _analytics_hoc2.default)(Select, 'onChange');
//# sourceMappingURL=index.js.map