'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _required = require('../icons/required');

var _required2 = _interopRequireDefault(_required);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Input component
 */
var Input = function (_PureComponent) {
  _inherits(Input, _PureComponent);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.getValue = function () {
      var _this2 = _this,
          inputNode = _this2.inputNode;


      return inputNode.value;
    }, _this.focus = function () {
      var _this3 = _this,
          inputNode = _this3.inputNode;


      inputNode.focus();
    }, _this.inputNode = null, _this.clearValue = function () {
      var _this4 = _this,
          inputNode = _this4.inputNode;


      inputNode.value = '';
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  /**
   * Return input value.
   * @return {string}
   */


  /**
   * Focus input element.
   */


  /**
   * Clear input value
   */


  _createClass(Input, [{
    key: '_renderRequiredIcon',


    /**
     * Render required icon element
     * @return {ReactElement} markup
     */
    value: function _renderRequiredIcon() {
      var required = this.props.required;


      return required && _react2.default.createElement(_required2.default, {
        className: 'input_required_icon fill_wrong'
      });
    }

    /**
     * render
     * @return {ReactElement} markup
     */

  }, {
    key: 'render',
    value: function render() {
      var _this5 = this,
          _classNames;

      var _props = this.props,
          tabIndex = _props.tabIndex,
          className = _props.className,
          defaultValue = _props.defaultValue,
          disabled = _props.disabled,
          multiLine = _props.multiLine,
          onChange = _props.onChange,
          type = _props.type,
          value = _props.value,
          required = _props.required,
          valid = _props.valid,
          placeholder = _props.placeholder,
          placeholderColor = _props.placeholderColor,
          children = _props.children,
          name = _props.name,
          bgType = _props.bgType,
          color = _props.color,
          textColor = _props.textColor,
          colorFocus = _props.colorFocus,
          colorError = _props.colorError,
          propsSize = _props.size,
          mobileSize = _props.mobileSize,
          inputProps = _props.inputProps,
          autoComplete = _props.autoComplete,
          autoFocus = _props.autoFocus,
          other = _objectWithoutProperties(_props, ['tabIndex', 'className', 'defaultValue', 'disabled', 'multiLine', 'onChange', 'type', 'value', 'required', 'valid', 'placeholder', 'placeholderColor', 'children', 'name', 'bgType', 'color', 'textColor', 'colorFocus', 'colorError', 'size', 'mobileSize', 'inputProps', 'autoComplete', 'autoFocus']);

      var device = this.context.device;

      var classNameInput = inputProps.className,
          otherInputProps = _objectWithoutProperties(inputProps, ['className']);

      var Component = multiLine ? 'textarea' : 'input';

      var size = propsSize || Input.defaultProps.size;

      if (device && mobileSize) {
        if (device.type === 'mobile') {
          size = mobileSize;
        }
      }

      return _react2.default.createElement(
        'div',
        _extends({
          'data-component': 'input',
          'data-type': bgType,
          'data-disabled': disabled,
          className: (0, _classnames2.default)('input', className)
        }, other),
        _react2.default.createElement(Component, _extends({
          ref: function ref(node) {
            _this5.inputNode = node;
          },
          type: multiLine ? null : type,
          className: (0, _classnames2.default)('input_field', 'round_small', ['input_field_' + size], (_classNames = {}, _defineProperty(_classNames, 'stroke_' + color, valid), _defineProperty(_classNames, 'stroke_' + colorError, !valid), _defineProperty(_classNames, 'input_field_focus_' + colorFocus, valid), _defineProperty(_classNames, 'fill_white', bgType === 'stroke'), _defineProperty(_classNames, 'fill_' + color, bgType === 'fill'), _defineProperty(_classNames, 'text_' + textColor, textColor), _classNames), ['input_placeholder_color_' + placeholderColor], classNameInput),
          tabIndex: tabIndex,
          defaultValue: defaultValue,
          disabled: disabled,
          onChange: onChange,
          value: value,
          required: required,
          placeholder: placeholder,
          name: name,
          autoComplete: autoComplete,
          autoFocus: autoFocus,
          'aria-invalid': !valid
        }, otherInputProps)),
        this._renderRequiredIcon(),
        children
      );
    }
  }]);

  return Input;
}(_react.PureComponent);

Input.propTypes = {
  /**
   * Element tabIndex.
   */
  tabIndex: _propTypes2.default.number,
  /**
   * The CSS class name of the wrapper element.
   */
  className: _propTypes2.default.string,
  /**
   * The default input value, useful when not controlling the component.
   */
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * If true, the input will be disabled.
   */
  disabled: _propTypes2.default.bool,
  /**
   * If true, a textarea element will be rendered.
   */
  multiLine: _propTypes2.default.bool,
  /**
   * Callback fired when the value is changed.
   */
  onChange: _propTypes2.default.func,
  /**
   * Type of the input element. It should be a valid HTML5 input type.
   */
  type: _propTypes2.default.string,
  /**
   * The input value, required for a controlled component.
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * If true, the input will be required.
   */
  required: _propTypes2.default.bool,
  /**
   * If false, the input will be unvalid styles.
   */
  valid: _propTypes2.default.bool,
  /**
   * The short hint displayed in the input before the user enters a value.
   */
  placeholder: _propTypes2.default.string,
  /**
   * Color for placeholder
   */
  placeholderColor: _propTypes2.default.string,
  // label: PropTypes.string,
  /**
   * This is what will be displayed in wrapper component.
   */
  children: _propTypes2.default.node,
  /**
   * Name attribute of the input element.
   */
  name: _propTypes2.default.string,
  /**
   * Component type one of `fill` or `stroke`.
   * If `fill` - component will be have background-color from `color` props.
   * If `stroke` - component will be have border-color from `color` props.
   */
  bgType: _propTypes2.default.oneOf(['fill', 'stroke']),
  /**
   * Component color from theme
   */
  color: _propTypes2.default.string,
  /**
   * Component text color from theme
   */
  textColor: _propTypes2.default.string,
  /**
   * Component focus color from the theme.
   */
  colorFocus: _propTypes2.default.string,
  /**
   * Component error color from the theme.
   */
  colorError: _propTypes2.default.string,
  /**
   * Component size.
   */
  size: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Component size for mobile.
   */
  mobileSize: _propTypes2.default.oneOf(['medium', 'large']),
  /**
   * Properties applied to the input element.
   */
  inputProps: _propTypes2.default.oneOfType([_propTypes2.default.object]),
  /**
   * This property helps users to fill forms faster, especially on mobile devices.
   * The name can be confusing, as it's more like an autofill.
   */
  autoComplete: _propTypes2.default.string,
  /**
   * If true, the input will be focused during the first mount.
   */
  autoFocus: _propTypes2.default.bool
};
Input.contextTypes = {
  device: _propTypes2.default.object
};
Input.defaultProps = {
  tabIndex: 0,
  className: '',
  defaultValue: undefined,
  disabled: false,
  multiLine: false,
  onChange: null,
  type: 'text',
  value: undefined,
  required: false,
  valid: true,
  placeholder: undefined,
  placeholderColor: 'grey_4',
  children: null,
  name: undefined,
  bgType: 'fill',
  color: 'light_grey',
  textColor: 'black',
  colorFocus: 'primary',
  colorError: 'wrong',
  size: 'medium',
  mobileSize: undefined,
  inputProps: {},
  autoComplete: undefined,
  autoFocus: false
};
exports.default = Input;
//# sourceMappingURL=input.js.map