'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactPopper = require('react-popper');

var _icons = require('../icons');

var _portal = require('../../containers/portal');

var _portal2 = _interopRequireDefault(_portal);

var _HTMLElementType = require('../../utils/HTMLElementType');

var _HTMLElementType2 = _interopRequireDefault(_HTMLElementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * TooltipPopper component
 * @description
 *  All props for Popper you can found on https://github.com/FezVrasta/react-popper.
 */
var TooltipPopper = function (_React$Component) {
  _inherits(TooltipPopper, _React$Component);

  function TooltipPopper() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TooltipPopper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TooltipPopper.__proto__ || Object.getPrototypeOf(TooltipPopper)).call.apply(_ref, [this].concat(args))), _this), _this.scheduleUpdate = function () {
      return null;
    }, _this.renderTooltipBody = function (_ref2) {
      var _ref3;

      var ref = _ref2.ref,
          _ref2$style = _ref2.style,
          top = _ref2$style.top,
          left = _ref2$style.left,
          position = _ref2$style.position,
          placement = _ref2.placement,
          arrowProps = _ref2.arrowProps,
          scheduleUpdate = _ref2.scheduleUpdate;
      var _this$props = _this.props,
          children = _this$props.children,
          arrow = _this$props.arrow,
          offset = _this$props.offset,
          color = _this$props.color,
          zIndex = _this$props.zIndex,
          classNameTooltip = _this$props.classNameTooltip,
          classNameTooltipContent = _this$props.classNameTooltipContent,
          showDelay = _this$props.showDelay;

      var direction = TooltipPopper.getDirection(placement);

      _this.scheduleUpdate = scheduleUpdate;

      return _react2.default.createElement(
        'div',
        {
          ref: ref,
          style: (_ref3 = {
            top: 0,
            left: 0,
            position: position,
            transform: 'translate3d(' + left + 'px, ' + top + 'px, 0)',
            transformOrigin: 'top center'
          }, _defineProperty(_ref3, 'padding' + direction, offset), _defineProperty(_ref3, 'zIndex', zIndex), _ref3),
          'data-component': 'tooltip_popper',
          className: classNameTooltip
        },
        _react2.default.createElement(
          'div',
          {
            className: (0, _classnames2.default)('tooltip', 'fill_' + color, 'shadow', 'round_small', 'break_word', classNameTooltipContent),
            'data-component': 'tooltip_content',
            'data-placement': placement,
            style: {
              animationDelay: showDelay + 'ms',
              MozAnimationDelay: showDelay + 'ms',
              WebkitAnimationDelay: showDelay + 'ms'
            }
          },
          arrow && _react2.default.createElement(
            'div',
            {
              ref: arrowProps.ref,
              style: arrowProps.style,
              'data-component': 'tooltip_arrow',
              className: 'tooltip_arrow'
            },
            _react2.default.createElement(_icons.RightTriangleIcon, {
              className: (0, _classnames2.default)('tooltip_arrow_icon', 'fill_' + color)
            })
          ),
          children
        )
      );
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TooltipPopper, [{
    key: 'UNSAFE_componentWillReceiveProps',
    value: function UNSAFE_componentWillReceiveProps() {
      // Make schedule to update tooltip, position if button position failed
      this.scheduleUpdate();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          referenceElement = _props.referenceElement,
          open = _props.open,
          placementProp = _props.placement,
          positionFixed = _props.positionFixed,
          usePortal = _props.usePortal,
          preventOverflow = _props.preventOverflow,
          preventFlip = _props.preventFlip,
          flipBoundaryElement = _props.flipBoundaryElement,
          children = _props.children,
          other = _objectWithoutProperties(_props, ['referenceElement', 'open', 'placement', 'positionFixed', 'usePortal', 'preventOverflow', 'preventFlip', 'flipBoundaryElement', 'children']);

      if (!open || !children) {
        return null;
      }

      var renderTooltip = _react2.default.createElement(
        _reactPopper.Popper,
        _extends({
          modifiers: {
            computeStyle: {
              gpuAcceleration: false
            },
            preventOverflow: {
              enabled: preventOverflow
            },
            hide: {
              enabled: preventOverflow
            },
            flip: {
              enabled: !preventFlip,
              boundariesElement: flipBoundaryElement
            }
          },
          placement: placementProp,
          referenceElement: referenceElement,
          positionFixed: positionFixed
        }, other),
        this.renderTooltipBody
      );

      if (usePortal) {
        return _react2.default.createElement(
          _portal2.default,
          { container: usePortal instanceof Element ? usePortal : null },
          renderTooltip
        );
      }

      return renderTooltip;
    }
  }], [{
    key: 'getDirection',
    value: function getDirection(placement) {
      if (placement) {
        if (placement.indexOf('right') === 0) {
          return 'Left';
        }
        if (placement.indexOf('left') === 0) {
          return 'Right';
        }
        if (placement.indexOf('bottom') === 0) {
          return 'Top';
        }
        if (placement.indexOf('top') === 0) {
          return 'Bottom';
        }
      }

      return '';
    }
  }]);

  return TooltipPopper;
}(_react2.default.Component);

exports.default = TooltipPopper;


TooltipPopper.propTypes = {
  /**
   * This is what will be displayed inside the popper.
   */
  children: _propTypes2.default.node,
  /**
   * If `true`, the popper arrow is shown.
   */
  arrow: _propTypes2.default.bool,
  /**
   * The `referenceObject` is an object that provides an interface
   * compatible with Popper.js and lets you use it as replacement of
   * a real DOM node.
   */
  referenceElement: _propTypes2.default.shape({
    clientHeight: _propTypes2.default.number,
    clientWidth: _propTypes2.default.number,
    getBoundingClientRect: _propTypes2.default.func
  }).isRequired,
  /**
   * If `true`, the popper is shown.
   */
  open: _propTypes2.default.bool,
  /**
   * Popper placement.
   */
  placement: _propTypes2.default.oneOf(['auto-start', 'auto', 'auto-end', 'top-start', 'top', 'top-end', 'right-start', 'right', 'right-end', 'bottom-end', 'bottom', 'bottom-start', 'left-end', 'left', 'left-start']),
  /**
   * Set this to `true` if you want popper to position it self in `fixed` mode.
   */
  positionFixed: _propTypes2.default.bool,
  /**
   * Padding from popper to `referenceElement` in `px`.
   */
  offset: _propTypes2.default.number,
  /**
   * Color for tooltip component.
   */
  color: _propTypes2.default.string,
  /**
   * Z-index for tooltip component.
   */
  zIndex: _propTypes2.default.number,
  /**
   * Use React portal for render tooltip to another elemenet.
   */
  usePortal: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.instanceOf(_HTMLElementType2.default)]),
  /**
   * Use preventOverflow for prevent overflow on tooltip.
   */
  preventOverflow: _propTypes2.default.bool,
  /**
   * Use preventFlip for prevent flipping tooltip, when no space.
   */
  preventFlip: _propTypes2.default.bool,
  /**
   * Class name for tooltip popper root element
   */
  classNameTooltip: _propTypes2.default.string,
  /**
   * Class name for tooltip popper content element
   */
  classNameTooltipContent: _propTypes2.default.string,
  /**
   * The number of milliseconds to wait before showing the tooltip.
   */
  showDelay: _propTypes2.default.number,
  /**
   * Flip boundary element modifier
   */
  flipBoundaryElement: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.instanceOf(_HTMLElementType2.default)])
};

TooltipPopper.defaultProps = {
  arrow: true,
  open: false,
  placement: 'auto',
  positionFixed: true,
  offset: 10,
  color: 'white',
  zIndex: 1,
  usePortal: false,
  preventOverflow: true,
  preventFlip: false,
  classNameTooltip: '',
  classNameTooltipContent: '',
  showDelay: 0,
  flipBoundaryElement: 'viewport',
  children: undefined
};
//# sourceMappingURL=tooltip_popper.js.map