'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _device_info = require('../../utils/device_info');

var _HTMLElementType = require('../../utils/HTMLElementType');

var _HTMLElementType2 = _interopRequireDefault(_HTMLElementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // eslint-disable-line


/**
 * DeviceProvider component
 */
var DeviceProvider = function (_PureComponent) {
  _inherits(DeviceProvider, _PureComponent);

  function DeviceProvider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DeviceProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DeviceProvider.__proto__ || Object.getPrototypeOf(DeviceProvider)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      device: (0, _device_info.getDeviceInfo)(_this.props.rootElement)
    }, _this.bindedResize = _this.onResize.bind(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DeviceProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        device: this.state.device
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.bindedResize);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.bindedResize);
    }

    /**
     * onResize window handler
     */

  }, {
    key: 'onResize',
    value: function onResize() {
      this.setState({
        device: (0, _device_info.getDeviceInfo)(this.props.rootElement)
      });
    }
  }, {
    key: 'render',


    /**
     * render
     * @return {ReactElement} markup
     */
    value: function render() {
      return this.props.children;
    }
  }]);

  return DeviceProvider;
}(_react.PureComponent);

DeviceProvider.propTypes = {
  /**
   * This is what will be displayed inside the DeviceProvider
   */
  children: _propTypes2.default.node,
  /**
   * The root where app is rendered
   */
  rootElement: _propTypes2.default.instanceOf(_HTMLElementType2.default)
};
DeviceProvider.childContextTypes = {
  device: _propTypes2.default.object
};
DeviceProvider.defaultProps = {
  children: null,
  rootElement: undefined
};
exports.default = DeviceProvider;
//# sourceMappingURL=index.js.map