'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _HTMLElementType = require('../../utils/HTMLElementType');

var _HTMLElementType2 = _interopRequireDefault(_HTMLElementType);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var useEnhancedEffect = typeof window !== 'undefined' ? _react2.default.useLayoutEffect : _react2.default.useEffect;

function getContainer(container) {
  return typeof container === 'function' ? container() : container;
}

/**
 * Portal component
 */
var Portal = function Portal(props) {
  var children = props.children,
      container = props.container,
      onRendered = props.onRendered;

  var _React$useState = _react2.default.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      mountNode = _React$useState2[0],
      setMountNode = _React$useState2[1];

  useEnhancedEffect(function () {
    setMountNode(getContainer(container) || document.body);

    if (onRendered) {
      onRendered();
    }
  }, [container, onRendered]);

  return mountNode ? _reactDom2.default.createPortal(children, mountNode) : _react2.default.createElement(_react2.default.Fragment, null);
};

Portal.propTypes = {
  /**
   * The children to render into the `container`.
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * A node, component instance, or function that returns either.
   * The `container` will have the portal children appended to it.
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: _propTypes2.default.oneOfType([// eslint-disable-line
  _propTypes2.default.func, _HTMLElementType2.default]),
  /**
   * Callback fired once the children has been mounted into the `container`.
   */
  onRendered: _propTypes2.default.func
};

Portal.defaultProps = {
  onRendered: undefined
};

exports.default = Portal;
//# sourceMappingURL=index.js.map