'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = SegueHandler;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } // eslint-disable-line


/**
 * SegueHandler component
 */
function SegueHandler(props) {
  var children = props.children,
      value = props.value,
      defaultValue = props.defaultValue,
      other = _objectWithoutProperties(props, ['children', 'value', 'defaultValue']);

  if (children.length && (value || defaultValue)) {
    for (var i = 0; i < children.length; i += 1) {
      var component = children[i];
      var _component$props = component.props,
          name = _component$props.name,
          notExtendProps = _component$props.notExtendProps;


      if (!value && name === defaultValue || value && name === value) {
        return (0, _react.cloneElement)(component, notExtendProps ? {} : _extends({}, other));
      }
    }

    console.error('\'defaultValue\' or \'value\' prop of the <SegueHandler /> is wrong!');
  }

  return _react2.default.createElement(_react.Fragment, null);
}

SegueHandler.propTypes = {
  /**
   * The content of the SegueHandler. This is usually used to pass SegueHandler elements
   */
  children: _propTypes2.default.node.isRequired,
  /**
   * Makes SegueHandler controllable and show the child whose value prop matches this prop
   */
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  /**
   * The text string to use for the default child show
   */
  defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
};

SegueHandler.defaultProps = {
  value: '',
  defaultValue: ''
};
//# sourceMappingURL=index.js.map