var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* eslint-disable react/forbid-prop-types */
/* eslint-disable react/require-default-props */
import * as React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';
import { Popper } from 'react-popper';
import TextField, { validationPropType } from '../text_field';
import SelectDropdown from '../select/select_dropdown';
import SelectItem from '../select/select_item';
import withAnalytics from '../../containers/analytics_hoc';

/**
 * Autocomplete component
 */

var Autocomplete = function (_React$Component) {
  _inherits(Autocomplete, _React$Component);

  function Autocomplete() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Autocomplete);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      showOptions: false,
      activeOption: _this.props.value || _this.props.defaultValue
    }, _this.setValue = function (value) {
      return _this.setState({
        activeOption: value
      });
    }, _this._refRootElement = React.createRef(), _this._refSelectDropdown = React.createRef(), _this.refTextField = React.createRef(), _this.handleClickOption = function (option, label) {
      return function (event) {
        var _this$props = _this.props,
            onChange = _this$props.onChange,
            name = _this$props.name,
            required = _this$props.required;
        var activeOption = _this.state.activeOption;

        // Prevent choose the same value.

        if (activeOption === label) {
          _this.setState({
            showOptions: false
          });

          return;
        }

        if ('value' in _this.props) {
          _this.setState({
            showOptions: false
          });
        } else {
          _this.setState({
            showOptions: false,
            activeOption: label
          });
        }

        if (typeof onChange === 'function') {
          event.persist();

          Object.defineProperty(event, 'target', {
            writable: true,
            value: {
              name: name,
              value: label,
              required: required
            }
          });

          onChange(event, option, 'select-option');
        }
      };
    }, _this.handleChangeField = function (event) {
      var onInputChange = _this.props.onInputChange;
      var value = event.currentTarget.value;


      if ('value' in _this.props) {
        _this.setState({
          showOptions: true
        });
      } else {
        _this.setState({
          showOptions: true,
          activeOption: value
        });
      }

      if (typeof onInputChange === 'function') {
        onInputChange(event);
      }
    }, _this.handleBlurField = function (event) {
      var onBlur = _this.props.onBlur;


      _this.setState({
        showOptions: false
      });

      if (typeof onBlur === 'function') {
        onBlur(event);
      }
    }, _this.handleClickField = function () {
      var disabled = _this.props.disabled;
      var showOptions = _this.state.showOptions;


      if (disabled) {
        return;
      }

      _this.setState({
        showOptions: !showOptions
      });
    }, _this.handleKeyDownField = function (event) {
      var _this$props2 = _this.props,
          disabled = _this$props2.disabled,
          onKeyDown = _this$props2.onKeyDown;
      var showOptions = _this.state.showOptions;


      if (disabled) {
        return;
      }

      if (typeof onKeyDown === 'function') {
        onKeyDown(event);
      }

      // Wait until IME is settled.
      if (event.which !== 229) {
        switch (event.key) {
          case 'ArrowUp':
            {
              // Prevent scroll of the page
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              _this.focusPrevOptionInDropdown();

              break;
            }

          case 'ArrowDown':
            {
              // Prevent scroll of the page
              event.preventDefault();

              if (!showOptions) {
                _this.setState({
                  showOptions: true
                });
              }

              _this.focusNextOptionInDropdown();

              break;
            }

          case 'Enter':
            {
              if (showOptions) {
                event.preventDefault();

                _this.clickOnFocusedOptionInDropdown();
              }

              break;
            }

          case 'Escape':
            {
              // Avoid Opera to exit fullscreen mode.
              event.preventDefault();
              // Avoid the Modal to handle the event.
              event.stopPropagation();

              _this.setState({
                showOptions: false
              });

              break;
            }

          default:
        }
      }
    }, _this.handleMouseDownForPreventBlur = function (event) {
      // Prevent blur
      event.preventDefault();
    }, _this.renderDropDown = function (options) {
      return function (props) {
        return React.createElement(
          'div',
          {
            ref: props.ref,
            style: {
              top: 0,
              left: 0,
              position: props.style.position,
              transform: 'translate3d(0px, ' + props.style.top + 'px, 0px)',
              transformOrigin: 'top center'
            },
            className: 'select_dropdown_container'
          },
          React.createElement(
            SelectDropdown,
            {
              ref: _this._refSelectDropdown,
              onMouseDown: _this.handleMouseDownForPreventBlur
            },
            _this.renderOptions(options)
          )
        );
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Autocomplete, [{
    key: 'getValue',


    /**
     * Get components value.
     * @return {string|number}
     */
    value: function getValue() {
      return this.state.activeOption;
    }

    /**
     * Set select value
     * @param {string|number} value
     */

  }, {
    key: 'getFillteredOptions',
    value: function getFillteredOptions() {
      var _props = this.props,
          options = _props.options,
          disableFiltering = _props.disableFiltering,
          getOptionLabel = _props.getOptionLabel;
      var _state = this.state,
          showOptions = _state.showOptions,
          activeOption = _state.activeOption;


      if (!showOptions) {
        return [];
      }

      if (disableFiltering) {
        return options;
      }

      return options.filter(function (option) {
        return getOptionLabel(option).toLowerCase().indexOf(activeOption.toLowerCase()) > -1;
      });
    }
  }, {
    key: 'focus',


    /**
     * Focus input element.
     */
    value: function focus() {
      this.refTextField.current.focus();
    }
  }, {
    key: 'focusPrevOptionInDropdown',
    value: function focusPrevOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption('prev');
      }
    }
  }, {
    key: 'focusNextOptionInDropdown',
    value: function focusNextOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.focusOption();
      }
    }
  }, {
    key: 'clickOnFocusedOptionInDropdown',
    value: function clickOnFocusedOptionInDropdown() {
      if (this._refSelectDropdown && this._refSelectDropdown.current) {
        this._refSelectDropdown.current.clickToFocusedElement();
      }
    }
  }, {
    key: 'renderOptions',
    value: function renderOptions(options) {
      var _this2 = this;

      var _props2 = this.props,
          renderOption = _props2.renderOption,
          size = _props2.size,
          getOptionDisabled = _props2.getOptionDisabled,
          getOptionLabel = _props2.getOptionLabel;
      var activeOption = this.state.activeOption;


      return options.map(function (option, index) {
        var label = getOptionLabel(option);
        var disabled = typeof getOptionDisabled === 'function' ? getOptionDisabled(option) : false;
        var content = typeof renderOption === 'function' ? renderOption(option) : label;

        return React.createElement(
          SelectItem,
          {
            key: label,
            'data-option-index': index,
            value: label,
            selected: label === activeOption,
            onClick: _this2.handleClickOption(option, label),
            size: size,
            disabled: disabled
          },
          content
        );
      });
    }
  }, {
    key: 'renderField',
    value: function renderField() {
      var _props3 = this.props,
          disabled = _props3.disabled,
          placeholder = _props3.placeholder,
          required = _props3.required,
          bgType = _props3.bgType,
          color = _props3.color,
          textColor = _props3.textColor,
          colorFocus = _props3.colorFocus,
          size = _props3.size,
          valid = _props3.valid,
          placeholderColor = _props3.placeholderColor,
          name = _props3.name,
          mobileSize = _props3.mobileSize,
          inputProps = _props3.inputProps,
          validation = _props3.validation,
          type = _props3.type,
          tabIndex = _props3.tabIndex,
          autoFocus = _props3.autoFocus,
          onFocus = _props3.onFocus;
      var activeOption = this.state.activeOption;


      return React.createElement(TextField, {
        autoComplete: 'off',
        onChange: this.handleChangeField,
        onBlur: this.handleBlurField,
        onFocus: onFocus,
        onClick: this.handleClickField,
        onKeyDown: this.handleKeyDownField,
        value: activeOption,
        disabled: disabled,
        placeholder: placeholder,
        required: required,
        bgType: bgType,
        color: color,
        textColor: textColor,
        colorFocus: colorFocus,
        size: size,
        valid: valid,
        placeholderColor: placeholderColor,
        name: name,
        mobileSize: mobileSize,
        inputProps: inputProps,
        validation: validation,
        type: type,
        tabIndex: tabIndex,
        autoFocus: autoFocus,
        ref: this.refTextField
      });
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup(options) {
      var _props4 = this.props,
          placement = _props4.placement,
          flip = _props4.flip;


      return React.createElement(
        Popper,
        {
          modifiers: {
            computeStyle: {
              gpuAcceleration: false
            },
            preventOverflow: {
              enabled: false
            },
            hide: {
              enabled: false
            },
            flip: {
              enabled: flip
            }
          },
          positionFixed: false,
          referenceElement: this._refRootElement ? this._refRootElement.current : null,
          placement: placement
        },
        this.renderDropDown(options)
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props5 = this.props,
          autoFocus = _props5.autoFocus,
          bgType = _props5.bgType,
          className = _props5.className,
          color = _props5.color,
          colorFocus = _props5.colorFocus,
          defaultValue = _props5.defaultValue,
          disabled = _props5.disabled,
          flip = _props5.flip,
          inputProps = _props5.inputProps,
          mobileSize = _props5.mobileSize,
          name = _props5.name,
          onBlur = _props5.onBlur,
          onFocus = _props5.onFocus,
          onChange = _props5.onChange,
          onInputChange = _props5.onInputChange,
          onKeyDown = _props5.onKeyDown,
          options = _props5.options,
          placeholder = _props5.placeholder,
          placeholderColor = _props5.placeholderColor,
          placement = _props5.placement,
          renderOption = _props5.renderOption,
          getOptionLabel = _props5.getOptionLabel,
          getOptionDisabled = _props5.getOptionDisabled,
          required = _props5.required,
          size = _props5.size,
          tabIndex = _props5.tabIndex,
          textColor = _props5.textColor,
          type = _props5.type,
          valid = _props5.valid,
          validation = _props5.validation,
          value = _props5.value,
          disableFiltering = _props5.disableFiltering,
          other = _objectWithoutProperties(_props5, ['autoFocus', 'bgType', 'className', 'color', 'colorFocus', 'defaultValue', 'disabled', 'flip', 'inputProps', 'mobileSize', 'name', 'onBlur', 'onFocus', 'onChange', 'onInputChange', 'onKeyDown', 'options', 'placeholder', 'placeholderColor', 'placement', 'renderOption', 'getOptionLabel', 'getOptionDisabled', 'required', 'size', 'tabIndex', 'textColor', 'type', 'valid', 'validation', 'value', 'disableFiltering']);

      var showOptions = this.state.showOptions;

      var filteredOptions = this.getFillteredOptions();
      var isOpen = showOptions && !!filteredOptions.length;

      return React.createElement(
        'div',
        _extends({}, other, {
          'data-component': 'autocomplete',
          className: classnames('autocomplete', className),
          ref: this._refRootElement
        }),
        this.renderField(),
        isOpen && this.renderPopup(filteredOptions)
      );
    }
  }], [{
    key: 'getDerivedStateFromProps',
    value: function getDerivedStateFromProps(props, state) {
      if ('value' in props && props.value !== state.activeOption) {
        return {
          activeOption: props.value
        };
      }

      return null;
    }
  }]);

  return Autocomplete;
}(React.Component);

Autocomplete.propTypes = {
  /**
   * The default input value, useful when not controlling the component.
   */
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  /**
   * The input value.
   */
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  /**
   * Array of options.
   */
  options: PropTypes.array.isRequired,
  /**
   * Render the option, use `getOptionLabel` by default.
   */
  renderOption: PropTypes.func,
  /**
   * Used to determine the disabled state for a given option.
   */
  getOptionDisabled: PropTypes.func,
  /**
   * Used to determine the string value for a given option.
   * It's used to fill the input (and the list box options if `renderOption` is not provided).
   */
  getOptionLabel: PropTypes.func,
  /**
   * If true, the input will be disabled.
   */
  disabled: PropTypes.bool,
  /**
   * The short hint displayed in the input before the user enters a value.
   */
  placeholder: PropTypes.string,
  /**
   * The CSS class name of the wrapper element.
   */
  className: PropTypes.string,
  /**
   * If true, the input will be required.
   */
  required: PropTypes.bool,
  /**
   * If false, the input will be unvalid styles.
   */
  valid: PropTypes.bool,
  /**
   * Component type one of `fill` or `stroke`.
   * If `fill` - component will be have background-color from `color` props.
   * If `stroke` - component will be have border-color from `color` props.
   */
  bgType: PropTypes.oneOf(['fill', 'stroke']),
  /**
   * Component color from theme.
   */
  color: PropTypes.string,
  /**
   * Component text color from theme.
   */
  textColor: PropTypes.string,
  /**
   * Color for the placeholder.
   */
  placeholderColor: PropTypes.string,
  /**
   * Component focus color from theme.
   */
  colorFocus: PropTypes.string,
  /**
   * Component size.
   */
  size: PropTypes.oneOf(['medium', 'large']),
  /**
   * Component size for mobile.
   */
  mobileSize: PropTypes.oneOf(['medium', 'large']),
  /**
   * Name attribute of the input element.
   */
  name: PropTypes.string,
  /**
   * Element tabIndex.
   */
  tabIndex: PropTypes.number,
  /**
   * If true, the input will be focused during the first mount.
   */
  autoFocus: PropTypes.bool,
  /**
   * Type of the input element.
   */
  type: PropTypes.oneOf(['text', 'email', 'tel']),
  /**
   * Properties applied to the input element.
   */
  inputProps: PropTypes.object,
  /**
   * Array with validation types.
   */
  validation: PropTypes.arrayOf(validationPropType),
  /**
   * Component dropdown start opened direction.
   */
  placement: PropTypes.oneOf(['top', 'bottom']),
  /**
   * If `true`, component will automatically calc possible dropdown opened direction.
   */
  flip: PropTypes.bool,
  /**
   * Callback fired when the value is changed.
   */
  onChange: PropTypes.func,
  /**
   * Callback fired when the input value changes.
   */
  onInputChange: PropTypes.func,
  /**
   * Callback fired when the input left focus.
   */
  onBlur: PropTypes.func,
  /**
   * Callback fired when the input receives focus.
   */
  onFocus: PropTypes.func,
  onKeyDown: PropTypes.func,
  /**
   * If `true`, the options can't be filtered.
   */
  disableFiltering: PropTypes.bool
};
Autocomplete.defaultProps = {
  defaultValue: '',
  getOptionLabel: function getOptionLabel(option) {
    return option.label || option;
  },
  disabled: false,
  required: false,
  bgType: 'stroke',
  color: 'light_grey',
  textColor: 'black',
  placeholderColor: 'grey_4',
  colorFocus: 'primary',
  size: 'medium',
  tabIndex: 0,
  autoFocus: false,
  inputProps: {},
  placement: 'bottom',
  flip: true,
  type: 'text',
  disableFiltering: false
};


export default withAnalytics(Autocomplete, 'onChange');
//# sourceMappingURL=index.js.map