var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import Prism from 'prismjs';
import classnames from 'classnames';
import 'prismjs/components/prism-jsx';
import 'prismjs/components/prism-bash';
import 'prismjs/components/prism-c';
import 'prismjs/components/prism-glsl';
import 'prismjs/components/prism-json';

/**
 * Highlight component
 */

var HighlightCode = function (_PureComponent) {
  _inherits(HighlightCode, _PureComponent);

  function HighlightCode() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, HighlightCode);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = HighlightCode.__proto__ || Object.getPrototypeOf(HighlightCode)).call.apply(_ref, [this].concat(args))), _this), _this.codeRef = React.createRef(), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(HighlightCode, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._highlight();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._highlight();
    }
  }, {
    key: '_highlight',
    value: function _highlight() {
      if (this.codeRef && this.codeRef.current) {
        Prism.highlightElement(this.codeRef.current);
      }
    }

    /**
     * render
     * @return {ReactElement} markup
     */

  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          lang = _props.lang,
          className = _props.className,
          other = _objectWithoutProperties(_props, ['children', 'lang', 'className']);

      return React.createElement(
        'pre',
        _extends({}, other, {
          'data-component': 'highlight_code',
          className: classnames(className, 'language-' + lang)
        }),
        React.createElement(
          'code',
          {
            ref: this.codeRef,
            className: 'language-' + lang
          },
          children
        )
      );
    }
  }]);

  return HighlightCode;
}(PureComponent);

HighlightCode.propTypes = {
  /**
   * This is what will be displayed inside the component
   */
  children: PropTypes.string.isRequired,
  /**
   * Supported highlighting languages
   */
  lang: PropTypes.oneOf(['css', 'html', 'javascript', 'js', 'jsx', 'markup', 'svg', 'xml', 'bash', 'glsl', 'none', 'json']),
  /**
   * Component root element class name.
   */
  className: PropTypes.string
};
HighlightCode.defaultProps = {
  lang: 'js',
  className: undefined
};
export default HighlightCode;
//# sourceMappingURL=index.js.map