export var countries = {
  AF: {
    name: 'Afghanistan',
    dialCode: '+93',
    format: '+.. ... ... ... ... ..',
    code: 'AF'
  },
  AL: {
    name: 'Albania',
    dialCode: '+355',
    format: '+... ... ... ... ... ..',
    code: 'AL'
  },
  DZ: {
    name: 'Algeria',
    dialCode: '+213',
    format: '+... ... ... ... ... ..',
    code: 'DZ'
  },
  AD: {
    name: 'Andorra',
    dialCode: '+376',
    format: '+... ... ... ... ... ..',
    code: 'AD'
  },
  AO: {
    name: 'Angola',
    dialCode: '+244',
    format: '+... ... ... ... ... ..',
    code: 'AO'
  },
  AG: {
    name: 'Antigua and Barbuda',
    dialCode: '+1268',
    format: '+.... ... ... ... ... ..',
    code: 'AG'
  },
  AR: {
    name: 'Argentina',
    dialCode: '+54',
    format: '+.. .. ........',
    code: 'AR'
  },
  AM: {
    name: 'Armenia',
    dialCode: '+374',
    format: '+... ... ... ... ... ..',
    code: 'AM'
  },
  AW: {
    name: 'Aruba',
    dialCode: '+297',
    format: '+... ... ... ... ... ..',
    code: 'AW'
  },
  AU: {
    name: 'Australia',
    dialCode: '+61',
    format: '+.. .. .... ....',
    code: 'AU'
  },
  AT: {
    name: 'Austria',
    dialCode: '+43',
    format: '+.. ... ... ... ... ..',
    code: 'AT'
  },
  AZ: {
    name: 'Azerbaijan',
    dialCode: '+994',
    format: '+... ... ... ... ... ..',
    code: 'AZ'
  },
  BS: {
    name: 'Bahamas',
    dialCode: '+1242',
    format: '+.... ... ... ... ... ..',
    code: 'BS'
  },
  BH: {
    name: 'Bahrain',
    dialCode: '+973',
    format: '+... ... ... ... ... ..',
    code: 'BH'
  },
  BD: {
    name: 'Bangladesh',
    dialCode: '+880',
    format: '+... ... ... ... ... ..',
    code: 'BD'
  },
  BB: {
    name: 'Barbados',
    dialCode: '+1246',
    format: '+.... ... ... ... ... ..',
    code: 'BB'
  },
  BY: {
    name: 'Belarus',
    dialCode: '+375',
    format: '+... .. ... .. ..',
    code: 'BY'
  },
  BE: {
    name: 'Belgium',
    dialCode: '+32',
    format: '+.. ... .. .. ..',
    code: 'BE'
  },
  BZ: {
    name: 'Belize',
    dialCode: '+501',
    format: '+... ... ... ... ... ..',
    code: 'BZ'
  },
  BJ: {
    name: 'Benin',
    dialCode: '+229',
    format: '+... ... ... ... ... ..',
    code: 'BJ'
  },
  BT: {
    name: 'Bhutan',
    dialCode: '+975',
    format: '+... ... ... ... ... ..',
    code: 'BT'
  },
  BO: {
    name: 'Bolivia',
    dialCode: '+591',
    format: '+... ... ... ... ... ..',
    code: 'BO'
  },
  BA: {
    name: 'Bosnia and Herzegovina',
    dialCode: '+387',
    format: '+... ... ... ... ... ..',
    code: 'BA'
  },
  BW: {
    name: 'Botswana',
    dialCode: '+267',
    format: '+... ... ... ... ... ..',
    code: 'BW'
  },
  BR: {
    name: 'Brazil',
    dialCode: '+55',
    format: '+.. .. .........',
    code: 'BR'
  },
  IO: {
    name: 'British Indian Ocean Territory',
    dialCode: '+246',
    format: '+... ... ... ... ... ..',
    code: 'IO'
  },
  BN: {
    name: 'Brunei',
    dialCode: '+673',
    format: '+... ... ... ... ... ..',
    code: 'BN'
  },
  BG: {
    name: 'Bulgaria',
    dialCode: '+359',
    format: '+... ... ... ... ... ..',
    code: 'BG'
  },
  BF: {
    name: 'Burkina Faso',
    dialCode: '+226',
    format: '+... ... ... ... ... ..',
    code: 'BF'
  },
  BI: {
    name: 'Burundi',
    dialCode: '+257',
    format: '+... ... ... ... ... ..',
    code: 'BI'
  },
  KH: {
    name: 'Cambodia',
    dialCode: '+855',
    format: '+... ... ... ... ... ..',
    code: 'KH'
  },
  CM: {
    name: 'Cameroon',
    dialCode: '+237',
    format: '+... ... ... ... ... ..',
    code: 'CM'
  },
  CA: {
    name: 'Canada',
    dialCode: '+1',
    format: '+. ... ... ....',
    code: 'CA'
  },
  CV: {
    name: 'Cape Verde',
    dialCode: '+238',
    format: '+... ... ... ... ... ..',
    code: 'CV'
  },
  BQ: {
    name: 'Caribbean Netherlands',
    dialCode: '+599',
    format: '+... ... ... ... ... ..',
    code: 'BQ'
  },
  CF: {
    name: 'Central African Republic',
    dialCode: '+236',
    format: '+... ... ... ... ... ..',
    code: 'CF'
  },
  TD: {
    name: 'Chad',
    dialCode: '+235',
    format: '+... ... ... ... ... ..',
    code: 'TD'
  },
  CL: {
    name: 'Chile',
    dialCode: '+56',
    format: '+.. ... ... ... ... ..',
    code: 'CL'
  },
  CN: {
    name: 'China',
    dialCode: '+86',
    format: '+.. .. .........',
    code: 'CN'
  },
  CO: {
    name: 'Colombia',
    dialCode: '+57',
    format: '+.. ... ... ... ... ..',
    code: 'CO'
  },
  KM: {
    name: 'Comoros',
    dialCode: '+269',
    format: '+... ... ... ... ... ..',
    code: 'KM'
  },
  CD: {
    name: 'Congo',
    dialCode: '+243',
    format: '+... ... ... ... ... ..',
    code: 'CD'
  },
  CG: {
    name: 'Congo',
    dialCode: '+242',
    format: '+... ... ... ... ... ..',
    code: 'CG'
  },
  CR: {
    name: 'Costa Rica',
    dialCode: '+506',
    format: '+... .... ....',
    code: 'CR'
  },
  CI: {
    name: 'Côte d’Ivoire',
    dialCode: '+225',
    format: '+... .. .. .. ..',
    code: 'CI'
  },
  HR: {
    name: 'Croatia',
    dialCode: '+385',
    format: '+... ... ... ... ... ..',
    code: 'HR'
  },
  CU: {
    name: 'Cuba',
    dialCode: '+53',
    format: '+.. ... ... ... ... ..',
    code: 'CU'
  },
  CW: {
    name: 'Curaçao',
    dialCode: '+599',
    format: '+... ... ... ... ... ..',
    code: 'CW'
  },
  CY: {
    name: 'Cyprus',
    dialCode: '+357',
    format: '+... .. ......',
    code: 'CY'
  },
  CZ: {
    name: 'Czech Republic',
    dialCode: '+420',
    format: '+... ... ... ... ... ..',
    code: 'CZ'
  },
  DK: {
    name: 'Denmark',
    dialCode: '+45',
    format: '+.. .. .. .. ..',
    code: 'DK'
  },
  DJ: {
    name: 'Djibouti',
    dialCode: '+253',
    format: '+... ... ... ... ... ..',
    code: 'DJ'
  },
  DM: {
    name: 'Dominica',
    dialCode: '+1767',
    format: '+.... ... ... ... ... ..',
    code: 'DM'
  },
  DO: {
    name: 'Dominican Republic',
    dialCode: '+1',
    format: '+. ... ... ... ... ..',
    code: 'DO'
  },
  EC: {
    name: 'Ecuador',
    dialCode: '+593',
    format: '+... ... ... ... ... ..',
    code: 'EC'
  },
  EG: {
    name: 'Egypt',
    dialCode: '+20',
    format: '+.. ... ... ... ... ..',
    code: 'EG'
  },
  SV: {
    name: 'El Salvador',
    dialCode: '+503',
    format: '+... .... ....',
    code: 'SV'
  },
  GQ: {
    name: 'Equatorial Guinea',
    dialCode: '+240',
    format: '+... ... ... ... ... ..',
    code: 'GQ'
  },
  ER: {
    name: 'Eritrea',
    dialCode: '+291',
    format: '+... ... ... ... ... ..',
    code: 'ER'
  },
  EE: {
    name: 'Estonia',
    dialCode: '+372',
    format: '+... .... ......',
    code: 'EE'
  },
  ET: {
    name: 'Ethiopia',
    dialCode: '+251',
    format: '+... ... ... ... ... ..',
    code: 'ET'
  },
  FJ: {
    name: 'Fiji',
    dialCode: '+679',
    format: '+... ... ... ... ... ..',
    code: 'FJ'
  },
  FI: {
    name: 'Finland',
    dialCode: '+358',
    format: '+... .. ... .. ..',
    code: 'FI'
  },
  FR: {
    name: 'France',
    dialCode: '+33',
    format: '+.. . .. .. .. ..',
    code: 'FR'
  },
  GF: {
    name: 'French Guiana',
    dialCode: '+594',
    format: '+... ... ... ... ... ..',
    code: 'GF'
  },
  PF: {
    name: 'French Polynesia',
    dialCode: '+689',
    format: '+... ... ... ... ... ..',
    code: 'PF'
  },
  GA: {
    name: 'Gabon',
    dialCode: '+241',
    format: '+... ... ... ... ... ..',
    code: 'GA'
  },
  GM: {
    name: 'Gambia',
    dialCode: '+220',
    format: '+... ... ... ... ... ..',
    code: 'GM'
  },
  GE: {
    name: 'Georgia',
    dialCode: '+995',
    format: '+... ... ... ... ... ..',
    code: 'GE'
  },
  DE: {
    name: 'Germany',
    dialCode: '+49',
    format: '+.. .... ........',
    code: 'DE'
  },
  GH: {
    name: 'Ghana',
    dialCode: '+233',
    format: '+... ... ... ... ... ..',
    code: 'GH'
  },
  GR: {
    name: 'Greece',
    dialCode: '+30',
    format: '+.. ... ... ... ... ..',
    code: 'GR'
  },
  GD: {
    name: 'Grenada',
    dialCode: '+1473',
    format: '+.... ... ... ... ... ..',
    code: 'GD'
  },
  GP: {
    name: 'Guadeloupe',
    dialCode: '+590',
    format: '+... ... ... ... ... ..',
    code: 'GP'
  },
  GU: {
    name: 'Guam',
    dialCode: '+1671',
    format: '+.... ... ... ... ... ..',
    code: 'GU'
  },
  GT: {
    name: 'Guatemala',
    dialCode: '+502',
    format: '+... .... ....',
    code: 'GT'
  },
  GN: {
    name: 'Guinea',
    dialCode: '+224',
    format: '+... ... ... ... ... ..',
    code: 'GN'
  },
  GW: {
    name: 'Guinea-Bissau',
    dialCode: '+245',
    format: '+... ... ... ... ... ..',
    code: 'GW'
  },
  GY: {
    name: 'Guyana',
    dialCode: '+592',
    format: '+... ... ... ... ... ..',
    code: 'GY'
  },
  HT: {
    name: 'Haiti',
    dialCode: '+509',
    format: '+... .... ....',
    code: 'HT'
  },
  HN: {
    name: 'Honduras',
    dialCode: '+504',
    format: '+... ... ... ... ... ..',
    code: 'HN'
  },
  HK: {
    name: 'Hong Kong',
    dialCode: '+852',
    format: '+... .... ....',
    code: 'HK'
  },
  HU: {
    name: 'Hungary',
    dialCode: '+36',
    format: '+.. ... ... ... ... ..',
    code: 'HU'
  },
  IS: {
    name: 'Iceland',
    dialCode: '+354',
    format: '+... ... ....',
    code: 'IS'
  },
  IN: {
    name: 'India',
    dialCode: '+91',
    format: '+.. ..... .....',
    code: 'IN'
  },
  ID: {
    name: 'Indonesia',
    dialCode: '+62',
    format: '+.. ... ... ... ... ..',
    code: 'ID'
  },
  IR: {
    name: 'Iran',
    dialCode: '+98',
    format: '+.. ... ... ....',
    code: 'IR'
  },
  IQ: {
    name: 'Iraq',
    dialCode: '+964',
    format: '+... ... ... ... ... ..',
    code: 'IQ'
  },
  IE: {
    name: 'Ireland',
    dialCode: '+353',
    format: '+... .. .......',
    code: 'IE'
  },
  IL: {
    name: 'Israel',
    dialCode: '+972',
    format: '+... ... ... ....',
    code: 'IL'
  },
  IT: {
    name: 'Italy',
    dialCode: '+39',
    format: '+.. ... .......',
    code: 'IT'
  },
  JM: {
    name: 'Jamaica',
    dialCode: '+1876',
    format: '+.... ... ... ... ... ..',
    code: 'JM'
  },
  JP: {
    name: 'Japan',
    dialCode: '+81',
    format: '+.. .. .... ....',
    code: 'JP'
  },
  JO: {
    name: 'Jordan',
    dialCode: '+962',
    format: '+... ... ... ... ... ..',
    code: 'JO'
  },
  KZ: {
    name: 'Kazakhstan',
    dialCode: '+7',
    format: '+. ... ... .. ..',
    code: 'KZ'
  },
  KE: {
    name: 'Kenya',
    dialCode: '+254',
    format: '+... ... ... ... ... ..',
    code: 'KE'
  },
  KI: {
    name: 'Kiribati',
    dialCode: '+686',
    format: '+... ... ... ... ... ..',
    code: 'KI'
  },
  XK: {
    name: 'Kosovo',
    dialCode: '+383',
    format: '+... ... ... ... ... ..',
    code: 'XK'
  },
  KW: {
    name: 'Kuwait',
    dialCode: '+965',
    format: '+... ... ... ... ... ..',
    code: 'KW'
  },
  KG: {
    name: 'Kyrgyzstan',
    dialCode: '+996',
    format: '+... ... ... ... ... ..',
    code: 'KG'
  },
  LA: {
    name: 'Laos',
    dialCode: '+856',
    format: '+... ... ... ... ... ..',
    code: 'LA'
  },
  LV: {
    name: 'Latvia',
    dialCode: '+371',
    format: '+... ... ... ... ... ..',
    code: 'LV'
  },
  LB: {
    name: 'Lebanon',
    dialCode: '+961',
    format: '+... ... ... ... ... ..',
    code: 'LB'
  },
  LS: {
    name: 'Lesotho',
    dialCode: '+266',
    format: '+... ... ... ... ... ..',
    code: 'LS'
  },
  LR: {
    name: 'Liberia',
    dialCode: '+231',
    format: '+... ... ... ... ... ..',
    code: 'LR'
  },
  LY: {
    name: 'Libya',
    dialCode: '+218',
    format: '+... ... ... ... ... ..',
    code: 'LY'
  },
  LI: {
    name: 'Liechtenstein',
    dialCode: '+423',
    format: '+... ... ... ... ... ..',
    code: 'LI'
  },
  LT: {
    name: 'Lithuania',
    dialCode: '+370',
    format: '+... ... ... ... ... ..',
    code: 'LT'
  },
  LU: {
    name: 'Luxembourg',
    dialCode: '+352',
    format: '+... ... ... ... ... ..',
    code: 'LU'
  },
  MO: {
    name: 'Macau',
    dialCode: '+853',
    format: '+... ... ... ... ... ..',
    code: 'MO'
  },
  MK: {
    name: 'Macedonia',
    dialCode: '+389',
    format: '+... ... ... ... ... ..',
    code: 'MK'
  },
  MG: {
    name: 'Madagascar',
    dialCode: '+261',
    format: '+... ... ... ... ... ..',
    code: 'MG'
  },
  MW: {
    name: 'Malawi',
    dialCode: '+265',
    format: '+... ... ... ... ... ..',
    code: 'MW'
  },
  MY: {
    name: 'Malaysia',
    dialCode: '+60',
    format: '+.. .. .... ....',
    code: 'MY'
  },
  MV: {
    name: 'Maldives',
    dialCode: '+960',
    format: '+... ... ... ... ... ..',
    code: 'MV'
  },
  ML: {
    name: 'Mali',
    dialCode: '+223',
    format: '+... ... ... ... ... ..',
    code: 'ML'
  },
  MT: {
    name: 'Malta',
    dialCode: '+356',
    format: '+... ... ... ... ... ..',
    code: 'MT'
  },
  MH: {
    name: 'Marshall Islands',
    dialCode: '+692',
    format: '+... ... ... ... ... ..',
    code: 'MH'
  },
  MQ: {
    name: 'Martinique',
    dialCode: '+596',
    format: '+... ... ... ... ... ..',
    code: 'MQ'
  },
  MR: {
    name: 'Mauritania',
    dialCode: '+222',
    format: '+... ... ... ... ... ..',
    code: 'MR'
  },
  MU: {
    name: 'Mauritius',
    dialCode: '+230',
    format: '+... ... ... ... ... ..',
    code: 'MU'
  },
  MX: {
    name: 'Mexico',
    dialCode: '+52',
    format: '+.. ... ... ....',
    code: 'MX'
  },
  FM: {
    name: 'Micronesia',
    dialCode: '+691',
    format: '+... ... ... ... ... ..',
    code: 'FM'
  },
  MD: {
    name: 'Moldova',
    dialCode: '+373',
    format: '+... .. .. .. ..',
    code: 'MD'
  },
  MC: {
    name: 'Monaco',
    dialCode: '+377',
    format: '+... ... ... ... ... ..',
    code: 'MC'
  },
  MN: {
    name: 'Mongolia',
    dialCode: '+976',
    format: '+... ... ... ... ... ..',
    code: 'MN'
  },
  ME: {
    name: 'Montenegro',
    dialCode: '+382',
    format: '+... ... ... ... ... ..',
    code: 'ME'
  },
  MA: {
    name: 'Morocco',
    dialCode: '+212',
    format: '+... ... ... ... ... ..',
    code: 'MA'
  },
  MZ: {
    name: 'Mozambique',
    dialCode: '+258',
    format: '+... ... ... ... ... ..',
    code: 'MZ'
  },
  MM: {
    name: 'Myanmar',
    dialCode: '+95',
    format: '+.. ... ... ... ... ..',
    code: 'MM'
  },
  NA: {
    name: 'Namibia',
    dialCode: '+264',
    format: '+... ... ... ... ... ..',
    code: 'NA'
  },
  NR: {
    name: 'Nauru',
    dialCode: '+674',
    format: '+... ... ... ... ... ..',
    code: 'NR'
  },
  NP: {
    name: 'Nepal',
    dialCode: '+977',
    format: '+... ... ... ... ... ..',
    code: 'NP'
  },
  NL: {
    name: 'Netherlands',
    dialCode: '+31',
    format: '+.. .. ........',
    code: 'NL'
  },
  NC: {
    name: 'New Caledonia',
    dialCode: '+687',
    format: '+... ... ... ... ... ..',
    code: 'NC'
  },
  NZ: {
    name: 'New Zealand',
    dialCode: '+64',
    format: '+.. ... ... ....',
    code: 'NZ'
  },
  NI: {
    name: 'Nicaragua',
    dialCode: '+505',
    format: '+... ... ... ... ... ..',
    code: 'NI'
  },
  NE: {
    name: 'Niger',
    dialCode: '+227',
    format: '+... ... ... ... ... ..',
    code: 'NE'
  },
  NG: {
    name: 'Nigeria',
    dialCode: '+234',
    format: '+... ... ... ... ... ..',
    code: 'NG'
  },
  KP: {
    name: 'North Korea',
    dialCode: '+850',
    format: '+... ... ... ... ... ..',
    code: 'KP'
  },
  NO: {
    name: 'Norway',
    dialCode: '+47',
    format: '+.. ... .. ...',
    code: 'NO'
  },
  OM: {
    name: 'Oman',
    dialCode: '+968',
    format: '+... ... ... ... ... ..',
    code: 'OM'
  },
  PK: {
    name: 'Pakistan',
    dialCode: '+92',
    format: '+.. ... .......',
    code: 'PK'
  },
  PW: {
    name: 'Palau',
    dialCode: '+680',
    format: '+... ... ... ... ... ..',
    code: 'PW'
  },
  PS: {
    name: 'Palestine',
    dialCode: '+970',
    format: '+... ... ... ... ... ..',
    code: 'PS'
  },
  PA: {
    name: 'Panama',
    dialCode: '+507',
    format: '+... ... ... ... ... ..',
    code: 'PA'
  },
  PG: {
    name: 'Papua New Guinea',
    dialCode: '+675',
    format: '+... ... ... ... ... ..',
    code: 'PG'
  },
  PY: {
    name: 'Paraguay',
    dialCode: '+595',
    format: '+... ... ... ... ... ..',
    code: 'PY'
  },
  PE: {
    name: 'Peru',
    dialCode: '+51',
    format: '+.. ... ... ... ... ..',
    code: 'PE'
  },
  PH: {
    name: 'Philippines',
    dialCode: '+63',
    format: '+.. .... .......',
    code: 'PH'
  },
  PL: {
    name: 'Poland',
    dialCode: '+48',
    format: '+.. ... ... ...',
    code: 'PL'
  },
  PT: {
    name: 'Portugal',
    dialCode: '+351',
    format: '+... ... ... ... ... ..',
    code: 'PT'
  },
  PR: {
    name: 'Puerto Rico',
    dialCode: '+1',
    format: '+. ... ... ... ... ..',
    code: 'PR'
  },
  QA: {
    name: 'Qatar',
    dialCode: '+974',
    format: '+... ... ... ... ... ..',
    code: 'QA'
  },
  RE: {
    name: 'Réunion',
    dialCode: '+262',
    format: '+... ... ... ... ... ..',
    code: 'RE'
  },
  RO: {
    name: 'Romania',
    dialCode: '+40',
    format: '+.. ... ... ... ... ..',
    code: 'RO'
  },
  RU: {
    name: 'Russia',
    dialCode: '+7',
    format: '+. ... ... .. ..',
    code: 'RU'
  },
  RW: {
    name: 'Rwanda',
    dialCode: '+250',
    format: '+... ... ... ... ... ..',
    code: 'RW'
  },
  KN: {
    name: 'Saint Kitts and Nevis',
    dialCode: '+1869',
    format: '+.... ... ... ... ... ..',
    code: 'KN'
  },
  LC: {
    name: 'Saint Lucia',
    dialCode: '+1758',
    format: '+.... ... ... ... ... ..',
    code: 'LC'
  },
  VC: {
    name: 'Saint Vincent and the Grenadines',
    dialCode: '+1784',
    format: '+.... ... ... ... ... ..',
    code: 'VC'
  },
  WS: {
    name: 'Samoa',
    dialCode: '+685',
    format: '+... ... ... ... ... ..',
    code: 'WS'
  },
  SM: {
    name: 'San Marino',
    dialCode: '+378',
    format: '+... ... ... ... ... ..',
    code: 'SM'
  },
  ST: {
    name: 'São Tomé and Príncipe',
    dialCode: '+239',
    format: '+... ... ... ... ... ..',
    code: 'ST'
  },
  SA: {
    name: 'Saudi Arabia',
    dialCode: '+966',
    format: '+... ... ... ... ... ..',
    code: 'SA'
  },
  SN: {
    name: 'Senegal',
    dialCode: '+221',
    format: '+... ... ... ... ... ..',
    code: 'SN'
  },
  RS: {
    name: 'Serbia',
    dialCode: '+381',
    format: '+... ... ... ... ... ..',
    code: 'RS'
  },
  SC: {
    name: 'Seychelles',
    dialCode: '+248',
    format: '+... ... ... ... ... ..',
    code: 'SC'
  },
  SL: {
    name: 'Sierra Leone',
    dialCode: '+232',
    format: '+... ... ... ... ... ..',
    code: 'SL'
  },
  SG: {
    name: 'Singapore',
    dialCode: '+65',
    format: '+.. .... ....',
    code: 'SG'
  },
  SK: {
    name: 'Slovakia',
    dialCode: '+421',
    format: '+... ... ... ... ... ..',
    code: 'SK'
  },
  SI: {
    name: 'Slovenia',
    dialCode: '+386',
    format: '+... ... ... ... ... ..',
    code: 'SI'
  },
  SB: {
    name: 'Solomon Islands',
    dialCode: '+677',
    format: '+... ... ... ... ... ..',
    code: 'SB'
  },
  SO: {
    name: 'Somalia',
    dialCode: '+252',
    format: '+... ... ... ... ... ..',
    code: 'SO'
  },
  ZA: {
    name: 'South Africa',
    dialCode: '+27',
    format: '+.. ... ... ... ... ..',
    code: 'ZA'
  },
  KR: {
    name: 'South Korea',
    dialCode: '+82',
    format: '+.. ... .... ....',
    code: 'KR'
  },
  SS: {
    name: 'South Sudan',
    dialCode: '+211',
    format: '+... ... ... ... ... ..',
    code: 'SS'
  },
  ES: {
    name: 'Spain',
    dialCode: '+34',
    format: '+.. ... ... ...',
    code: 'ES'
  },
  LK: {
    name: 'Sri Lanka',
    dialCode: '+94',
    format: '+.. ... ... ... ... ..',
    code: 'LK'
  },
  SD: {
    name: 'Sudan',
    dialCode: '+249',
    format: '+... ... ... ... ... ..',
    code: 'SD'
  },
  SR: {
    name: 'Suriname',
    dialCode: '+597',
    format: '+... ... ... ... ... ..',
    code: 'SR'
  },
  SZ: {
    name: 'Swaziland',
    dialCode: '+268',
    format: '+... ... ... ... ... ..',
    code: 'SZ'
  },
  SE: {
    name: 'Sweden',
    dialCode: '+46',
    format: '+.. ... ... ...',
    code: 'SE'
  },
  CH: {
    name: 'Switzerland',
    dialCode: '+41',
    format: '+.. .. ... .. ..',
    code: 'CH'
  },
  SY: {
    name: 'Syria',
    dialCode: '+963',
    format: '+... ... ... ... ... ..',
    code: 'SY'
  },
  TW: {
    name: 'Taiwan',
    dialCode: '+886',
    format: '+... ... ... ... ... ..',
    code: 'TW'
  },
  TJ: {
    name: 'Tajikistan',
    dialCode: '+992',
    format: '+... ... ... ... ... ..',
    code: 'TJ'
  },
  TZ: {
    name: 'Tanzania',
    dialCode: '+255',
    format: '+... ... ... ... ... ..',
    code: 'TZ'
  },
  TH: {
    name: 'Thailand',
    dialCode: '+66',
    format: '+.. ... ... ... ... ..',
    code: 'TH'
  },
  TL: {
    name: 'Timor-Leste',
    dialCode: '+670',
    format: '+... ... ... ... ... ..',
    code: 'TL'
  },
  TG: {
    name: 'Togo',
    dialCode: '+228',
    format: '+... ... ... ... ... ..',
    code: 'TG'
  },
  TO: {
    name: 'Tonga',
    dialCode: '+676',
    format: '+... ... ... ... ... ..',
    code: 'TO'
  },
  TT: {
    name: 'Trinidad and Tobago',
    dialCode: '+1868',
    format: '+.... ... ... ... ... ..',
    code: 'TT'
  },
  TN: {
    name: 'Tunisia',
    dialCode: '+216',
    format: '+... ... ... ... ... ..',
    code: 'TN'
  },
  TR: {
    name: 'Turkey',
    dialCode: '+90',
    format: '+.. ... ... .. ..',
    code: 'TR'
  },
  TM: {
    name: 'Turkmenistan',
    dialCode: '+993',
    format: '+... ... ... ... ... ..',
    code: 'TM'
  },
  TV: {
    name: 'Tuvalu',
    dialCode: '+688',
    format: '+... ... ... ... ... ..',
    code: 'TV'
  },
  UG: {
    name: 'Uganda',
    dialCode: '+256',
    format: '+... ... ... ... ... ..',
    code: 'UG'
  },
  UA: {
    name: 'Ukraine',
    dialCode: '+380',
    format: '+... .. ... ....',
    code: 'UA'
  },
  AE: {
    name: 'United Arab Emirates',
    dialCode: '+971',
    format: '+... ... ... ... ... ..',
    code: 'AE'
  },
  GB: {
    name: 'United Kingdom',
    dialCode: '+44',
    format: '+.. .... ......',
    code: 'GB'
  },
  US: {
    name: 'United States',
    dialCode: '+1',
    format: '+. ... ... ....',
    code: 'US'
  },
  UY: {
    name: 'Uruguay',
    dialCode: '+598',
    format: '+... ... ... ... ... ..',
    code: 'UY'
  },
  UZ: {
    name: 'Uzbekistan',
    dialCode: '+998',
    format: '+... ... ... ... ... ..',
    code: 'UZ'
  },
  VU: {
    name: 'Vanuatu',
    dialCode: '+678',
    format: '+... ... ... ... ... ..',
    code: 'VU'
  },
  VA: {
    name: 'Vatican City',
    dialCode: '+39',
    format: '+.. .. .... ....',
    code: 'VA'
  },
  VE: {
    name: 'Venezuela',
    dialCode: '+58',
    format: '+.. ... ... ... ... ..',
    code: 'VE'
  },
  VN: {
    name: 'Vietnam',
    dialCode: '+84',
    format: '+.. ... ... ... ... ..',
    code: 'VN'
  },
  YE: {
    name: 'Yemen',
    dialCode: '+967',
    format: '+... ... ... ... ... ..',
    code: 'YE'
  },
  ZM: {
    name: 'Zambia',
    dialCode: '+260',
    format: '+... ... ... ... ... ..',
    code: 'ZM'
  },
  ZW: {
    name: 'Zimbabwe',
    dialCode: '+263',
    format: '+... ... ... ... ... ..',
    code: 'ZW'
  }
};

export default countries;
//# sourceMappingURL=countries.js.map