var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import * as React from 'react';
import PropTypes from 'prop-types';
import icons from './raw_countries_icons';

/**
 * CountryIcon component.
 */
var CountryIcon = function CountryIcon(props) {
  var code = props.code,
      other = _objectWithoutProperties(props, ['code']);

  var icon = icons[code];

  if (!icon) {
    return null;
  }

  return React.createElement('svg', _extends({}, other, {
    xmlns: 'http://www.w3.org/2000/svg',
    viewBox: icon[0]
    // eslint-disable-next-line react/no-danger
    , dangerouslySetInnerHTML: { __html: icon[1] }
  }));
};

CountryIcon.propTypes = {
  code: PropTypes.string.isRequired
};

export default CountryIcon;
//# sourceMappingURL=country_icon.js.map