var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import * as React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

/**
 * SelectDropdown component
 */

var SelectDropdown = function (_React$PureComponent) {
  _inherits(SelectDropdown, _React$PureComponent);

  function SelectDropdown() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SelectDropdown);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SelectDropdown.__proto__ || Object.getPrototypeOf(SelectDropdown)).call.apply(_ref, [this].concat(args))), _this), _this._refRootElement = React.createRef(), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SelectDropdown, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._scrollToSelectedElement();
    }
  }, {
    key: 'getFocusedElement',
    value: function getFocusedElement() {
      return this._refRootElement.current.querySelector('[data-focused="true"]');
    }
  }, {
    key: 'getSelectedElement',
    value: function getSelectedElement() {
      return this._refRootElement.current.querySelector('[aria-selected="true"]');
    }
  }, {
    key: 'getValueMatchedElement',
    value: function getValueMatchedElement(value) {
      var children = this._refRootElement.current.children;

      var el = void 0;

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = children[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var child = _step.value;

          var text = child.textContent;

          if (text) {
            text = text.trim().toLowerCase();

            if (text[0] === value) {
              el = child;

              break;
            }
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return el;
    }
  }, {
    key: '_scrollToSelectedElement',
    value: function _scrollToSelectedElement() {
      var el = this.getSelectedElement();

      this._scrollToElement(el);
    }
  }, {
    key: '_scrollToElement',
    value: function _scrollToElement(el) {
      if (el) {
        this._refRootElement.current.scrollTop = el.offsetTop;
      }
    }
  }, {
    key: 'clickToFocusedElement',
    value: function clickToFocusedElement() {
      var el = this.getFocusedElement();

      if (el) {
        el.click();
      }
    }
  }, {
    key: '_isChildDisabled',
    value: function _isChildDisabled(childIndex) {
      var children = this.props.children;

      var child = children[childIndex];

      if (child && child.props) {
        return child.props.disabled;
      }

      return false;
    }

    /**
     * Returns next not disabled element focus index using decrease strategy.
     * @param {number} focusedIndex - current focused element index.
     * @returns {number}
     */

  }, {
    key: '_getPrevFocusIndex',
    value: function _getPrevFocusIndex(focusedIndex) {
      var _this2 = this;

      var children = this.props.children;


      var getIndex = function getIndex(index) {
        var nextFocusedIndex = void 0;

        if (index - 1 < 0) {
          nextFocusedIndex = children.length - 1;
        } else {
          nextFocusedIndex = index - 1;
        }

        // Prevent `Maximum call stack size`.
        if (index === nextFocusedIndex) {
          return focusedIndex;
        }

        var isNextFocusedChildDisabled = _this2._isChildDisabled(nextFocusedIndex);

        if (isNextFocusedChildDisabled) {
          return getIndex(nextFocusedIndex);
        }

        return nextFocusedIndex;
      };

      return getIndex(focusedIndex);
    }

    /**
     * Returns next not disabled element focus index using increase strategy.
     * @param {number} focusedIndex - current focused element index.
     * @returns {number}
     */

  }, {
    key: '_getNextFocusIndex',
    value: function _getNextFocusIndex(focusedIndex) {
      var _this3 = this;

      var children = this.props.children;


      var getIndex = function getIndex(index) {
        var nextFocusedIndex = void 0;

        if (index + 1 > children.length - 1) {
          nextFocusedIndex = 0;
        } else {
          nextFocusedIndex = index + 1;
        }

        // Prevent `Maximum call stack size`.
        if (index === nextFocusedIndex) {
          return focusedIndex;
        }

        var isNextFocusedChildDisabled = _this3._isChildDisabled(nextFocusedIndex);

        if (isNextFocusedChildDisabled) {
          return getIndex(nextFocusedIndex);
        }

        return nextFocusedIndex;
      };

      return getIndex(focusedIndex);
    }
  }, {
    key: 'focusOptionByValue',
    value: function focusOptionByValue(value) {
      // Support match only by one letter.
      if (value.length !== 1) {
        return;
      }

      var focusedElement = this.getFocusedElement();
      var matchedElement = this.getValueMatchedElement(value);

      if (matchedElement) {
        if (focusedElement) {
          focusedElement.removeAttribute('data-focused');
        }

        matchedElement.setAttribute('data-focused', 'true');
        this._scrollToElement(matchedElement);
      }
    }
  }, {
    key: 'focusOption',
    value: function focusOption(type) {
      var selectedElement = this.getSelectedElement();
      var focusedElement = this.getFocusedElement();
      var selectedIndex = void 0;
      var focusedIndex = void 0;

      if (selectedElement) {
        selectedIndex = Number(selectedElement.getAttribute('data-option-index'));
      }

      if (focusedElement) {
        focusedIndex = Number(focusedElement.getAttribute('data-option-index'));
      }

      // Use `selectedIndex` if `focusedIndex` not defined.
      if (typeof focusedIndex !== 'number') {
        focusedIndex = selectedIndex || -1;
      }

      var nextFocusedIndex = void 0;

      if (type === 'prev') {
        nextFocusedIndex = this._getPrevFocusIndex(focusedIndex);
      } else {
        nextFocusedIndex = this._getNextFocusIndex(focusedIndex);
      }

      var nextFocusedElement = this._refRootElement.current.querySelector('[data-option-index="' + nextFocusedIndex + '"]');

      if (nextFocusedElement) {
        // Remove focus from prev focused element.
        if (focusedElement) {
          focusedElement.removeAttribute('data-focused');
        }

        nextFocusedElement.setAttribute('data-focused', 'true');
        this._scrollToElement(nextFocusedElement);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          color = _props.color,
          other = _objectWithoutProperties(_props, ['children', 'className', 'color']);

      return React.createElement(
        'ul',
        _extends({
          'data-component': 'select_dropdown',
          className: classNames('select_dropdown', ['fill_' + color], 'round_small', 'shadow_medium', className),
          ref: this._refRootElement,
          role: 'listbox'
        }, other),
        children
      );
    }
  }]);

  return SelectDropdown;
}(React.PureComponent);

SelectDropdown.propTypes = {
  /**
   * This is what will be displayed inside the dropdown list.
   */
  children: PropTypes.node,
  /**
   * The CSS class name of the root element.
   */
  className: PropTypes.string,
  /**
   * Component color from theme.
   */
  color: PropTypes.string
};
SelectDropdown.defaultProps = {
  children: null,
  className: '',
  color: 'white'
};
export default SelectDropdown;
//# sourceMappingURL=select_dropdown.js.map