var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react'; // eslint-disable-line
import PropTypes from 'prop-types';
import { getDeviceInfo } from '../../utils/device_info';
import HTMLElementType from '../../utils/HTMLElementType';

/**
 * DeviceProvider component
 */

var DeviceProvider = function (_PureComponent) {
  _inherits(DeviceProvider, _PureComponent);

  function DeviceProvider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DeviceProvider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DeviceProvider.__proto__ || Object.getPrototypeOf(DeviceProvider)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      device: getDeviceInfo(_this.props.rootElement)
    }, _this.bindedResize = _this.onResize.bind(_this), _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DeviceProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        device: this.state.device
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      window.addEventListener('resize', this.bindedResize);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.bindedResize);
    }

    /**
     * onResize window handler
     */

  }, {
    key: 'onResize',
    value: function onResize() {
      this.setState({
        device: getDeviceInfo(this.props.rootElement)
      });
    }
  }, {
    key: 'render',


    /**
     * render
     * @return {ReactElement} markup
     */
    value: function render() {
      return this.props.children;
    }
  }]);

  return DeviceProvider;
}(PureComponent);

DeviceProvider.propTypes = {
  /**
   * This is what will be displayed inside the DeviceProvider
   */
  children: PropTypes.node,
  /**
   * The root where app is rendered
   */
  rootElement: PropTypes.instanceOf(HTMLElementType)
};
DeviceProvider.childContextTypes = {
  device: PropTypes.object
};
DeviceProvider.defaultProps = {
  children: null,
  rootElement: undefined
};
export default DeviceProvider;
//# sourceMappingURL=index.js.map