var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

import React from 'react';
import ReactDOM from 'react-dom';
import PropTypes from 'prop-types';
import HTMLElementType from '../../utils/HTMLElementType';

var useEnhancedEffect = typeof window !== 'undefined' ? React.useLayoutEffect : React.useEffect;

function getContainer(container) {
  return typeof container === 'function' ? container() : container;
}

/**
 * Portal component
 */
var Portal = function Portal(props) {
  var children = props.children,
      container = props.container,
      onRendered = props.onRendered;

  var _React$useState = React.useState(null),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      mountNode = _React$useState2[0],
      setMountNode = _React$useState2[1];

  useEnhancedEffect(function () {
    setMountNode(getContainer(container) || document.body);

    if (onRendered) {
      onRendered();
    }
  }, [container, onRendered]);

  return mountNode ? ReactDOM.createPortal(children, mountNode) : React.createElement(React.Fragment, null);
};

Portal.propTypes = {
  /**
   * The children to render into the `container`.
   */
  children: PropTypes.node.isRequired,
  /**
   * A node, component instance, or function that returns either.
   * The `container` will have the portal children appended to it.
   * By default, it uses the body of the top-level document object,
   * so it's simply `document.body` most of the time.
   */
  container: PropTypes.oneOfType([// eslint-disable-line
  PropTypes.func, HTMLElementType]),
  /**
   * Callback fired once the children has been mounted into the `container`.
   */
  onRendered: PropTypes.func
};

Portal.defaultProps = {
  onRendered: undefined
};

export default Portal;
//# sourceMappingURL=index.js.map