var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React, { cloneElement, Fragment } from 'react'; // eslint-disable-line
import PropTypes from 'prop-types';

/**
 * SegueHandler component
 */
export default function SegueHandler(props) {
  var children = props.children,
      value = props.value,
      defaultValue = props.defaultValue,
      other = _objectWithoutProperties(props, ['children', 'value', 'defaultValue']);

  if (children.length && (value || defaultValue)) {
    for (var i = 0; i < children.length; i += 1) {
      var component = children[i];
      var _component$props = component.props,
          name = _component$props.name,
          notExtendProps = _component$props.notExtendProps;


      if (!value && name === defaultValue || value && name === value) {
        return cloneElement(component, notExtendProps ? {} : _extends({}, other));
      }
    }

    console.error('\'defaultValue\' or \'value\' prop of the <SegueHandler /> is wrong!');
  }

  return React.createElement(Fragment, null);
}

SegueHandler.propTypes = {
  /**
   * The content of the SegueHandler. This is usually used to pass SegueHandler elements
   */
  children: PropTypes.node.isRequired,
  /**
   * Makes SegueHandler controllable and show the child whose value prop matches this prop
   */
  value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
  /**
   * The text string to use for the default child show
   */
  defaultValue: PropTypes.oneOfType([PropTypes.string, PropTypes.number])
};

SegueHandler.defaultProps = {
  value: '',
  defaultValue: ''
};
//# sourceMappingURL=index.js.map